# Hinarī 4-Corner

Resource naming based on fixed reserved keyword list so auto native filenames are possible.  
This set should be defined in lingua terminator DB using 72 bit tree slugs...

Rules:

- gemstone: 20 words + 4 words extension (is 3 x V144Tocta's or 54 x byte)
- gemfolder: 24 words, max 4 levels
- one gemglyph word is 18 bit (see V018Tord)
- one gemglyph word has one fixed meaning to have hard-coded translations
- In unicode file paths use the HinarīX9 encoding of The Word
- if gemstone name is lesser then 20 words than use MIN as seperator

org: bundle/org.apache.felix.scr-2.2.0.jar  
num: 27712/80606-17120-44960-83150-10100-10100-10307.61011-81417  
4CNH: יֽ֕זְ֔/זֲ֟דֲ֩יֳ֟ײֳ֔יֳ֞וֶ֕זֵ֟ױֳ֩רְ֠װֶ֔רְ֠װֶ֔װֽ֕רֶ֔יֽ֔יֽ֔װֶ֕וְ֕ײֵ֔וֲ֩  

## Hardware friendly

Full path is fixed size, for example when we use The word number;

- filename: 24 x V018Tord = 3 x V144Tocta = 54 bytes
- path: 4 x 24 x V018Tord = 12 x V144Tocta = 216 bytes
- HyperdriveId: 64 chars = 2 x V144Tocta = 32 bytes

Gives total of 302 bytes or 17 x V144Tocta for hardware based blockchain files.

## Example data

Four corner code lookup:
[mdbg.net](https://www.mdbg.net/chinese/dictionary?page=chardict)

	warp = 2291.4 = 紝 = weave, lay warp 
	hash = 0022.0 = 廁 = toilet, lavatory; mingle with
	sea = 3815.7 = 海 = sea, ocean; maritime 
	file = 7520.6 = 陣 = column, row or file of troops 
	mine = 5500.0 = 井 = well, mine shaft, pit 
	java = 6101.1 = 啡 = morphine; coffee
	jar = 8141.7 = 瓶 = jug, pitcher, vase, jar, bottle 
	bundle = 2771.2 = 包 = wrap, pack, bundle; package
	organization = 8060.6 = 會 = to assemble, meet together; a meeting; an organization
	feather = 1712.0 = 羽 = feather, plume; wings; rad. 124
	flower = 4496.0 = 葙 = feather cockscomb (Celosia argentea)
	inject = 8315.0 = 鍼 = needle, pin, tack; prick; inject
	promise = 0864.0 = 許 = allow, permit; promise; betroth
	method = 4321.0 = 朮 = skill, art; method; trick, device
	container = 7710.0 = 皿 = shallow container; rad. no. 108 
	system = 2220.0 = 制 = system; establish; overpower 
	temple = 3060.6 = 宮 = palace, temple, dwelling, enclose
	dependency = 2411.1 = 靠 = lean on, trust, depend on; near
	zero = 1030.7 = 零 = zero; fragment, fraction
	one = 1000.0 = 一 = one; a, an; alone
	two = 1010.0 = 二 = two; twice 
	three = 1010.1 = 三 = three
	four = 6021.0 = 四 = four
	
	immortal = 2227.0 = 仙 = Taoist super-being, transcendent, immortal
	highest = 2110.0 = 上 = top; superior, highest; go up, send up
	lord = 0010.4 = 主 = master, chief owner; host; lord
	heaven = 1043.0 = 天 = sky, heaven; god, celestial
	
	blue = 4410.7 = 藍 = blue; indigo plant; surname
	white = 2466.1 = 皓 = bright, luminous; clear; hoary
	red = 2191.0 = 紅 = red, vermillion; blush, flush
	orange = 4291.8 = 橙 = orange
	green = 2793.2 = 綠 = green; chlorine
	yellow = 4480.6 = 黃 = yellow; surname 
	brown = 3622.7 = 褐 = coarse woolen cloth; dull, dark
	black = 6033.1 = 黑 = black; dark; evil, sinister
	purple = 2497.0 = 紺 = dark blue or reddish color

With fixed keyword list coding, all abstract internal computing resource naming is localized;

	4CNH: יֽ֕זְ֔/זֲ֟דֲ֩יֳ֟ײֳ֔יֳ֞וֶ֕זֵ֟ױֳ֩רְ֠װֶ֔רְ֠װֶ֔װֽ֕רֶ֔יֽ֔יֽ֔װֶ֕וְ֕ײֵ֔וֲ֩  
	en: bundle/organization-feather-flower-inject-two-two-zero.java-jar
	nl: bundel/organisatie-veerkracht-bloem-injecteren-twee-twee-nul.java-kan
	hi: बंडल/संगठन-पंख-फूल-इंजेक्षन-दो-दो-शून्य.जावा-जार
	cn: 捆／組織－羽毛－花－注入－二－二－零。爪哇－罐

See only China has it own full language, all other fake languages lift on latin whitespace.

## Hinarī Encoding

See bassboon T008ᖟGun which has;

- T008ᖟGunHinarī 
- T008ᖟGunHinarīSupplement6
- T008ᖟGunHinarīSupplement9

Results in;

	HinarīX3: ייייייווווווזוװװדירדײײדיריײיייזוױרױי
	HinarīX6: יֽיֽיֽוַוַוַזַװֲדֽרֻײֵדֽרֽײֽיֽזַױֳױֽ
	HinarīX9: יֽ֔יֽ֔וַ֝וַ֝זַ֟װֻ֔רֻ֕ײֻ֔רֽ֕יֽ֔זַ֩רֶ֔
	
	//MIN+MAX+#immortal+#highest+#lord+#heaven
	V018Tord[] {0,262143,22270,21100,00104,10430};
	
An adult CPU is 18 bit, thus "יֽ֔יֽ֔" is like 0x00 in hex.
