package love.distributedrebirth.no2all.nostr.fire;

import java.util.List;

import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTag;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTagMeta;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagA;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagAlt;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagClient;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagContentWarning;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagD;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagDescription;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagE;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagI;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagImage;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagName;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagNonce;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagP;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagPublishedAt;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagR;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagSubject;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagSummary;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagT;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagThumb;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagTitle;

public class NoStrFireStackWelder implements NoStrFireStackFishWelder,
	NoStrTagA.FishWelder,
	NoStrTagAlt.FishWelder,
	NoStrTagClient.FishWelder,
	NoStrTagContentWarning.FishWelder,
	NoStrTagD.FishWelder,
	NoStrTagDescription.FishWelder,
	NoStrTagE.FishWelder,
	NoStrTagI.FishWelder,
	NoStrTagImage.FishWelder,
	NoStrTagName.FishWelder,
	NoStrTagNonce.FishWelder,
	NoStrTagP.FishWelder,
	NoStrTagPublishedAt.FishWelder,
	NoStrTagR.FishWelder,
	NoStrTagSubject.FishWelder,
	NoStrTagSummary.FishWelder,
	NoStrTagT.FishWelder,
	NoStrTagThumb.FishWelder,
	NoStrTagTitle.FishWelder
{
	private final NoStrFireWaterWelder welder;

	protected NoStrFireStackWelder(NoStrFireWaterWelder welder) {
		this.welder = welder;
	}

	public NoStrFireWaterWelder burn() {
		return welder;
	}

	@Override
	public NoStrFireStackWelder tag(NoStrEventTag eventTag) {
		welder.smokeTag(eventTag);
		return this;
	}

	public NoStrFireStackWelder tags(List<NoStrEventTag> eventTags) {
		eventTags.forEach(v -> welder.smokeTag(v));
		return this;
	}

	public NoStrFireStackWelder tag(NoStrEventTagMeta tag, String... args) {
		return tag(NoStrEventTag.valueOf(tag, args));
	}

	public NoStrFireStackWelder tag(String tag, String... args) {
		return tag(NoStrEventTagMeta.valueOf(tag), args);
	}
}
