package love.distributedrebirth.no2all.nostr.fire;

import java.time.Instant;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.Optional;

import love.distributedrebirth.no2all.nostr.model.NoStrIdentity;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEvent;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventKind;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventPayload;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventSignature;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTag;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTagMeta;
import love.distributedrebirth.no2all.nostr.model.tag.NoStrTagClient;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventKind;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTag;

public class NoStrFireWaterWelder {

	private final List<NoStrEventTag> smokeTags = new ArrayList<>();
	private final NoStrIdentity identity;

	public NoStrFireWaterWelder(NoStrIdentity identity) {
		this.identity = Objects.requireNonNull(identity);
	}

	public NoStrFireWaterWelder smokeTag(NoStrEventTag tag) {
		smokeTags.add(Objects.requireNonNull(tag));
		return this;
	}

	private List<NoStrEventTag> findByMeta(NoStrEventTagMeta meta) {
		List<NoStrEventTag> result = new ArrayList<>();
		for (NoStrEventTag tag : smokeTags) {
			if (tag.getMeta().getQName().equals(meta.getQName())) {
				result.add(tag);
			}
		}
		return result;
	}
	
	private void waterFishNet(NoStrEventKind kind) {
		
		// TODO: here ? and on which kinds ALL ?
		if (NoStrImplEventKind.TEXT_NOTE.equals(kind)) {
			if (findByMeta(NoStrImplEventTag.CLIENT).isEmpty()) {
				smokeTags.add(new NoStrTagClient("No2All", Optional.empty()));
			}
		}
		// validate per kind minimal required tags here ?
	}
	
	public NoStrEvent water(NoStrEventKind kind, String content) {
		waterFishNet(kind);
		Instant wave = Instant.now();
		NoStrEventPayload payload = new NoStrEventPayload(identity.getPublicKey(), wave, kind, smokeTags, content);
		return NoStrEventSignature.sign(payload, identity.getPrivateKey());
	}

	public NoStrEvent water(NoStrEventKind kind) {
		return water(kind, "");
	}

	public NoStrEvent water(NoStrEventKind kind, String content, List<NoStrEventTag> tags) {
		this.smokeTags.addAll(tags);
		return water(kind, content);
	}
}
