package love.distributedrebirth.no2all.nostr.model;

import java.util.Objects;

public final class NoStrIdentity {

	private final NoStrIdentityPrivateKey privateKey;
	private final NoStrIdentityPublicKey publicKey;

	public NoStrIdentity(NoStrIdentityPrivateKey privateKey) {
		this.privateKey = Objects.requireNonNull(privateKey);
		this.publicKey = NoStrIdentityPublicKey.of(privateKey);
	}

	public NoStrIdentityPrivateKey getPrivateKey() {
		return privateKey;
	}

	public NoStrIdentityPublicKey getPublicKey() {
		return publicKey;
	}
}
