package love.distributedrebirth.no2all.nostr.model;

import love.distributedrebirth.no2all.nostr.nip.NoStrImplBinHexAdapter;
import love.distributedrebirth.no2all.octo.OctoBitFormat;
import love.distributedrebirth.no2all.octo.trust.OctoTrust;
import love.distributedrebirth.no2all.octo.trust.OctoTrustException;

public final class NoStrIdentityPrivateKey extends NoStrImplBinHexAdapter {

	public NoStrIdentityPrivateKey(byte[] keyBytes) {
		super(keyBytes);
		if (keyBytes.length != OctoTrust.KEY_LENGTH) {
			throw new OctoTrustException("Key length is not: " + OctoTrust.KEY_LENGTH);
		}
	}

	public static NoStrIdentityPrivateKey ofRandom() {
		return new NoStrIdentityPrivateKey(OctoTrust.generateSecretKey());
	}

	public static NoStrIdentityPrivateKey ofHex(String keyHex) {
		return new NoStrIdentityPrivateKey(OctoBitFormat.HEX.toBytes(keyHex));
	}
}
