package love.distributedrebirth.no2all.nostr.model;

import love.distributedrebirth.no2all.nostr.nip.NoStrImplBinHexAdapter;
import love.distributedrebirth.no2all.octo.OctoBitFormat;
import love.distributedrebirth.no2all.octo.trust.OctoTrust;
import love.distributedrebirth.no2all.octo.trust.OctoTrustException;
import love.distributedrebirth.no2all.octo.trust.OctoTrustSchnorr;

public final class NoStrIdentityPublicKey extends NoStrImplBinHexAdapter {

	public NoStrIdentityPublicKey(byte[] keyBytes) {
		super(keyBytes);
		if (keyBytes.length != OctoTrust.KEY_LENGTH) {
			throw new OctoTrustException("Key length is not: " + OctoTrust.KEY_LENGTH);
		}
	}

	public static NoStrIdentityPublicKey ofHex(String keyHex) {
		return new NoStrIdentityPublicKey(OctoBitFormat.HEX.toBytes(keyHex));
	}

	public static NoStrIdentityPublicKey of(NoStrIdentityPrivateKey privateKey) {
		return new NoStrIdentityPublicKey(OctoTrustSchnorr.extractPublicKey(privateKey.getBytes()));
	}
}
