package love.distributedrebirth.no2all.nostr.model;

import java.util.HashMap;
import java.util.Map;

import jakarta.json.Json;
import jakarta.json.JsonObject;
import jakarta.json.JsonString;
import jakarta.json.JsonValue;
import love.distributedrebirth.no2all.nostr.NoStrGospel;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplQName;

public final class NoStrProfileMetaData implements NoStrGospel {

	private final Map<String, String> fields = new HashMap<>();

	public NoStrProfileMetaData() {
	}

	public NoStrProfileMetaData(JsonObject value) {
		for (String fieldName : value.keySet()) {
			JsonValue fieldValue = value.get(fieldName);
			if (fieldValue instanceof JsonString) {
				fields.put(fieldName, ((JsonString)fieldValue).getString());
			}
		}
	}

	@Override
	public JsonValue toBible() {
		return Json.createObjectBuilder(fields).build();
	}

	private enum QName implements NoStrImplQName {

		NAME,
		DISPLAY_NAME,
		ABOUT,
		WEBSITE,
		PICTURE,
		BANNER,
		NIP05,
		LUD16
		;

		private final String jsonQName;

		private QName() {
			jsonQName = name().toLowerCase();
		}

		@Override
		public String getQName() {
			return jsonQName;
		}
	}

	public String getName() {
		return fields.get(QName.NAME.getQName());
	}

	public void setName(String name) {
		this.fields.put(QName.NAME.getQName(), name);
	}

	public String getDisplayName() {
		return fields.get(QName.DISPLAY_NAME.getQName());
	}

	public void setDisplayName(String displayName) {
		this.fields.put(QName.DISPLAY_NAME.getQName(), displayName);
	}

	public String getAbout() {
		return fields.get(QName.ABOUT.getQName());
	}

	public void setAbout(String about) {
		this.fields.put(QName.ABOUT.getQName(), about);
	}

	public String getWebsite() {
		return fields.get(QName.WEBSITE.getQName());
	}

	public void setWebsite(String website) {
		this.fields.put(QName.WEBSITE.getQName(), website);
	}

	public String getPicture() {
		return fields.get(QName.PICTURE.getQName());
	}

	public void setPicture(String picture) {
		this.fields.put(QName.PICTURE.getQName(), picture);
	}

	public String getBanner() {
		return fields.get(QName.BANNER.getQName());
	}

	public void setBanner(String banner) {
		this.fields.put(QName.BANNER.getQName(), banner);
	}

	public String getNip05() {
		return fields.get(QName.NIP05.getQName());
	}

	public void setNip05(String nip05) {
		this.fields.put(QName.NIP05.getQName(), nip05);
	}

	public String getLud16() {
		return fields.get(QName.LUD16.getQName());
	}

	public void setLud16(String lud16) {
		this.fields.put(QName.LUD16.getQName(), lud16);
	}
}
