package love.distributedrebirth.no2all.nostr.model;

import java.util.ArrayList;
import java.util.List;

import jakarta.json.Json;
import jakarta.json.JsonObject;
import jakarta.json.JsonObjectBuilder;
import jakarta.json.JsonValue;
import love.distributedrebirth.no2all.nostr.NoStrGospel;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplChuch;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplQName;

public final class NoStrRelayInfoPayment implements NoStrGospel {

	private final List<NoStrKindValue> kinds = new ArrayList<>();
	private Integer amount;
	private String unit;

	public NoStrRelayInfoPayment(int amount, String unit) {
		this.amount = amount;
		this.unit = unit;
	}
	
	public NoStrRelayInfoPayment(JsonObject json) {
		NoStrKindValue.readArrayKinds(json, QName.KINDS, kinds);
		amount = NoStrImplChuch.readInteger(json, QName.AMOUNT);
		unit = NoStrImplChuch.readString(json, QName.UNIT);
	}

	@Override
	public JsonValue toBible() {
		JsonObjectBuilder result = Json.createObjectBuilder();
		NoStrKindValue.writeArrayKinds(result, QName.KINDS, kinds);
		NoStrImplChuch.writeInteger(result, QName.AMOUNT, amount);
		NoStrImplChuch.writeString(result, QName.UNIT, unit);
		return result.build();
	}
	
	private enum QName implements NoStrImplQName {

		KINDS,
		AMOUNT,
		UNIT,
		;

		private final String jsonQName;

		private QName() {
			jsonQName = name().toLowerCase();
		}

		@Override
		public String getQName() {
			return jsonQName;
		}
	}

	public List<NoStrKindValue> getKinds() {
		return kinds;
	}

	public Integer getAmount() {
		return amount;
	}

	public void setAmount(Integer amount) {
		this.amount = amount;
	}

	public String getUnit() {
		return unit;
	}

	public void setUnit(String unit) {
		this.unit = unit;
	}
}
