package love.distributedrebirth.no2all.nostr.model;

import java.util.ArrayList;
import java.util.List;

import jakarta.json.Json;
import jakarta.json.JsonObject;
import jakarta.json.JsonObjectBuilder;
import jakarta.json.JsonValue;
import love.distributedrebirth.no2all.nostr.NoStrGospel;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplChuch;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplQName;

public final class NoStrRelayInfoRetention implements NoStrGospel {

	private final List<NoStrKindValue> kinds = new ArrayList<>();
	private Integer time;
	private Integer count;

	public NoStrRelayInfoRetention() {
	}

	public NoStrRelayInfoRetention(Integer time, Integer count) {
		this.time = time;
		this.count = count;
	}

	public NoStrRelayInfoRetention(JsonObject json) {
		NoStrKindValue.readArrayKinds(json, QName.KINDS, kinds);
		time = NoStrImplChuch.readInteger(json, QName.TIME);
		count = NoStrImplChuch.readInteger(json, QName.COUNT);
	}

	@Override
	public JsonValue toBible() {
		JsonObjectBuilder result = Json.createObjectBuilder();
		NoStrKindValue.writeArrayKinds(result, QName.KINDS, kinds);
		NoStrImplChuch.writeInteger(result, QName.TIME, time);
		NoStrImplChuch.writeInteger(result, QName.COUNT, count);
		return result.build();
	}
	
	private enum QName implements NoStrImplQName {

		KINDS,
		TIME,
		COUNT,
		;

		private final String jsonQName;

		private QName() {
			jsonQName = name().toLowerCase();
		}

		@Override
		public String getQName() {
			return jsonQName;
		}
	}

	public List<NoStrKindValue> getKinds() {
		return kinds;
	}

	public Integer getTime() {
		return time;
	}

	public void setTime(Integer time) {
		this.time = time;
	}

	public Integer getCount() {
		return count;
	}

	public void setCount(Integer count) {
		this.count = count;
	}
}
