package love.distributedrebirth.no2all.nostr.model.event;

import java.util.Objects;
import java.util.Optional;

import love.distributedrebirth.no2all.nostr.nip.NoStrImplQName;

public class NoStrEventTagBaseMono implements NoStrEventTag {

	private final NoStrEventTagMeta meta;
	private String[] args;

	public NoStrEventTagBaseMono(NoStrEventTagMeta meta) {
		this(meta, new String[1]);
	}

	public NoStrEventTagBaseMono(NoStrEventTagMeta meta, String[] args) {
		this.meta = Objects.requireNonNull(meta);
		this.args = Objects.requireNonNull(args);
	}

	@Override
	public NoStrEventTagMeta getMeta() {
		return meta;
	}

	@Override
	public String[] getMetaArguments() {
		return args;
	}

	public Optional<String> getMetaArgument() {
		return NoStrEventTag.super.getMetaArgument(0);
	}

	protected void setMetaArgumentStr(String value) {
		args[0] = value;
	}

	protected void setMetaArgumentOptStr(Optional<String> value) {
		if (value.isEmpty()) {
			return;
		}
		setMetaArgumentStr(value.get());
	}

	protected void setMetaArgumentOptQName(Optional<? extends NoStrImplQName> value) {
		if (value.isEmpty()) {
			return;
		}
		setMetaArgumentStr(value.get().getQName());
	}
}
