package love.distributedrebirth.no2all.nostr.model.event;

import java.util.Objects;

import love.distributedrebirth.no2all.nostr.nip.NoStrImpl;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTag;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplPossibility;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplQFlag;

public class NoStrEventTagMetaCustom implements NoStrEventTagMeta {

	private static final NoStrImplPossibility[] UNKNOWN_NIPS = new NoStrImplPossibility[] { NoStrImpl.NIP_0_UNKNOWN };
	private final String qName;
	private final boolean quariable;

	public NoStrEventTagMetaCustom(String qName) {
		this.qName = Objects.requireNonNull(qName);
		this.quariable = NoStrImplEventTag.isQuariable(qName);
	}

	@Override
	public String getQName() {
		return qName;
	}

	@Override
	public String getQFlag() {
		return NoStrImplQFlag.CUSTOM_INDICATOR;
	}

	@Override
	public NoStrImplPossibility[] getNips() {
		return UNKNOWN_NIPS;
	}

	@Override
	public boolean isQuariable() {
		return quariable;
	}

	@Override
	public boolean isSinglton() {
		return false;
	}
}
