package love.distributedrebirth.no2all.nostr.model.message;

import java.util.Objects;

import jakarta.json.Json;
import jakarta.json.JsonArray;
import jakarta.json.JsonString;
import jakarta.json.JsonValue;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplMessageType;

public final class NoStrMsgToClientAuth implements NoStrMsgToClient {

	private final String challenge;

	public NoStrMsgToClientAuth(String challenge) {
		this.challenge = Objects.requireNonNull(challenge);
	}

	public NoStrMsgToClientAuth(JsonArray json) {
		this.challenge = ((JsonString)json.get(1)).getString();
	}

	@Override
	public JsonValue toBible() {
		return Json.createArrayBuilder()
				.add(NoStrImplMessageType.AUTH.getQName())
				.add(challenge)
			.build();
	}

	public String getChallenge() {
		return challenge;
	}
}
