package love.distributedrebirth.no2all.nostr.model.message;

import java.util.Objects;

import jakarta.json.Json;
import jakarta.json.JsonArray;
import jakarta.json.JsonString;
import jakarta.json.JsonValue;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplMessageType;

public final class NoStrMsgToClientCount implements NoStrMsgToClient {

	private final String QNAME_COUNT = "count";
	private final String subscriptionId;
	private final int count;

	public NoStrMsgToClientCount(String subscriptionId, int count) {
		this.subscriptionId = Objects.requireNonNull(subscriptionId);
		this.count = count;
	}

	public NoStrMsgToClientCount(JsonArray json) {
		this.subscriptionId = ((JsonString)json.get(1)).getString();
		this.count = json.get(2).asJsonObject().getInt(QNAME_COUNT);
	}

	@Override
	public JsonValue toBible() {
		return Json.createArrayBuilder()
				.add(NoStrImplMessageType.COUNT.getQName())
				.add(subscriptionId)
				.add(Json.createObjectBuilder().add(QNAME_COUNT, count))
			.build();
	}

	public String getSubscriptionId() {
		return subscriptionId;
	}

	public int getCount() {
		return count;
	}
}
