package love.distributedrebirth.no2all.nostr.model.message;

import java.util.Objects;

import jakarta.json.Json;
import jakarta.json.JsonArray;
import jakarta.json.JsonString;
import jakarta.json.JsonValue;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEvent;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplMessageType;

public final class NoStrMsgToClientEvent implements NoStrMsgToClient {

	private final String subscriptionId;
	private final NoStrEvent event;

	public NoStrMsgToClientEvent(String subscriptionId, NoStrEvent event) {
		this.subscriptionId = Objects.requireNonNull(subscriptionId);
		this.event = Objects.requireNonNull(event);
	}

	public NoStrMsgToClientEvent(JsonArray json) {
		this.subscriptionId = ((JsonString)json.get(1)).getString();
		this.event = new NoStrEvent(json.get(2).asJsonObject());
	}

	@Override
	public JsonValue toBible() {
		return Json.createArrayBuilder()
				.add(NoStrImplMessageType.EVENT.getQName())
				.add(subscriptionId)
				.add(event.toBible())
			.build();
	}

	public String getSubscriptionId() {
		return subscriptionId;
	}

	public NoStrEvent getEvent() {
		return event;
	}
}
