package love.distributedrebirth.no2all.nostr.model.message;

import java.util.Objects;

import jakarta.json.Json;
import jakarta.json.JsonArray;
import jakarta.json.JsonString;
import jakarta.json.JsonValue;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplMessageType;

public final class NoStrMsgToClientNotice implements NoStrMsgToClient {

	private final String message;

	public NoStrMsgToClientNotice(String message) {
		this.message = Objects.requireNonNull(message);
	}

	public NoStrMsgToClientNotice(JsonArray json) {
		this.message = ((JsonString)json.get(1)).getString();
	}

	@Override
	public JsonValue toBible() {
		return Json.createArrayBuilder()
				.add(NoStrImplMessageType.NOTICE.getQName())
				.add(message)
			.build();
	}

	public String getMessage() {
		return message;
	}
}
