package love.distributedrebirth.no2all.nostr.model.message;

import java.util.Objects;

import jakarta.json.Json;
import jakarta.json.JsonArray;
import jakarta.json.JsonString;
import jakarta.json.JsonValue;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplMessageType;

public final class NoStrMsgToRelayClose implements NoStrMsgToRelay {

	private final String subscriptionId;

	public NoStrMsgToRelayClose(String subscriptionId) {
		this.subscriptionId = Objects.requireNonNull(subscriptionId);
	}

	public NoStrMsgToRelayClose(JsonArray json) {
		this.subscriptionId = ((JsonString)json.get(1)).getString();
	}

	@Override
	public JsonValue toBible() {
		return Json.createArrayBuilder()
				.add(NoStrImplMessageType.CLOSE.getQName())
				.add(subscriptionId)
			.build();
	}

	public String getSubscriptionId() {
		return subscriptionId;
	}
}
