package love.distributedrebirth.no2all.nostr.model.message;

import java.util.Objects;

import jakarta.json.Json;
import jakarta.json.JsonArray;
import jakarta.json.JsonValue;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEvent;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplMessageType;

public final class NoStrMsgToRelayEvent implements NoStrMsgToRelay {

	private final NoStrEvent event;

	public NoStrMsgToRelayEvent(NoStrEvent event) {
		this.event = Objects.requireNonNull(event);
	}

	public NoStrMsgToRelayEvent(JsonArray json) {
		this.event = new NoStrEvent(json.get(1).asJsonObject());
	}

	@Override
	public JsonValue toBible() {
		return Json.createArrayBuilder()
			.add(NoStrImplMessageType.EVENT.getQName())
			.add(event.toBible())
		.build();
	}

	public NoStrEvent getEvent() {
		return event;
	}
}
