package love.distributedrebirth.no2all.nostr.model.share;

import java.util.Objects;

import love.distributedrebirth.no2all.nostr.nip.NoStrImplShareLink;
import love.distributedrebirth.no2all.octo.OctoBech32;
import love.distributedrebirth.no2all.octo.OctoBech32String;

public abstract class NoStrShareB32LinkBare implements NoStrShareLink {

	private final String shareLink;
	private final byte[] bareValue;

	public NoStrShareB32LinkBare(NoStrImplShareLink linkType, OctoBech32String link) {
		this(linkType, OctoBech32.fromBech32(linkType.validate(link)).getData());
	}

	public NoStrShareB32LinkBare(NoStrImplShareLink linkType, byte[] bareValue) {
		Objects.requireNonNull(bareValue);
		this.shareLink = OctoBech32.toBech32(linkType.getPrefix(), bareValue).getValue();
		this.bareValue = bareValue;
	}

	@Override
	public final String toShareLink() {
		return shareLink;
	}

	protected byte[] getBareValue() {
		return bareValue;
	}
}
