package love.distributedrebirth.no2all.nostr.model.share;

import java.util.List;
import java.util.Optional;

import love.distributedrebirth.no2all.nostr.model.NoStrIdentityPublicKey;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventId;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventKind;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplShareLink;
import love.distributedrebirth.no2all.octo.OctoBech32String;

public final class NoStrShareLinkEvent extends NoStrShareB32LinkTLV {

	public NoStrShareLinkEvent(OctoBech32String link) {
		super(NoStrImplShareLink.EVENT, link);
	}

	public NoStrShareLinkEvent(NoStrEventId eventId) {
		this(eventId, List.of(), Optional.empty(), Optional.empty());
	}

	public NoStrShareLinkEvent(NoStrEventId eventId, List<String> relays, Optional<NoStrIdentityPublicKey> author, Optional<NoStrEventKind> kind) {
		super(NoStrImplShareLink.EVENT, tapeStudio -> {
			tapeStudio.recordSpecial(eventId.getBytes());
			tapeStudio.recordRelays(relays);
			tapeStudio.recordAuthor(author);
			tapeStudio.recordKind(kind);
		});
	}

	public NoStrEventId getEventId() {
		return new NoStrEventId(getTapeDeck().playSpecial().get().array());
	}

	public List<String> getRelays() {
		return getTapeDeck().playRelays();
	}

	public Optional<NoStrIdentityPublicKey> getAuthorId() {
		return getTapeDeck().playAuthor();
	}

	public Optional<NoStrEventKind> getKind() {
		return getTapeDeck().playKind();
	}

	public static NoStrShareLinkEvent ofB32(String linkB32) {
		return new NoStrShareLinkEvent(OctoBech32String.of(linkB32));
	}
}
