package love.distributedrebirth.no2all.nostr.model.share;

import java.util.List;
import java.util.Objects;

import love.distributedrebirth.no2all.nostr.model.NoStrIdentityPublicKey;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventKind;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplShareLink;
import love.distributedrebirth.no2all.octo.OctoBech32String;
import love.distributedrebirth.no2all.octo.OctoBitFormat;

public final class NoStrShareLinkEventReference extends NoStrShareB32LinkTLV {

	public NoStrShareLinkEventReference(OctoBech32String link) {
		super(NoStrImplShareLink.EVENT_REFERENCE, link);
	}

	public NoStrShareLinkEventReference(String refDValue, List<String> relays, NoStrIdentityPublicKey author, NoStrEventKind kind) {
		super(NoStrImplShareLink.EVENT_REFERENCE, tapeStudio -> {
			tapeStudio.recordSpecial(refDValue, OctoBitFormat.UTF8);
			tapeStudio.recordRelays(relays);
			tapeStudio.recordAuthor(author);
			tapeStudio.recordKind(Objects.requireNonNull(kind));
		});
	}

	public String getReferenceDValue() {
		return getTapeDeck().playSpecial(OctoBitFormat.UTF8).get();
	}

	public List<String> getRelays() {
		return getTapeDeck().playRelays();
	}

	public NoStrIdentityPublicKey getAuthorId() {
		return getTapeDeck().playAuthor().get();
	}

	public NoStrEventKind getKind() {
		return getTapeDeck().playKind().get();
	}

	public static NoStrShareLinkEventReference ofB32(String linkB32) {
		return new NoStrShareLinkEventReference(OctoBech32String.of(linkB32));
	}
}
