package love.distributedrebirth.no2all.nostr.model.share;

import java.util.List;

import love.distributedrebirth.no2all.nostr.model.NoStrIdentityPublicKey;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplShareLink;
import love.distributedrebirth.no2all.octo.OctoBech32String;

public final class NoStrShareLinkProfile extends NoStrShareB32LinkTLV {

	public NoStrShareLinkProfile(OctoBech32String link) {
		super(NoStrImplShareLink.PROFILE, link);
	}

	public NoStrShareLinkProfile(NoStrIdentityPublicKey publicKey, List<String> relays) {
		super(NoStrImplShareLink.PROFILE, tapeStudio -> {
			tapeStudio.recordSpecial(publicKey.getBytes());
			tapeStudio.recordRelays(relays);
		});
	}

	public NoStrIdentityPublicKey getPublicKey() {
		return new NoStrIdentityPublicKey(getTapeDeck().playSpecial().get().array());
	}

	public List<String> getRelays() {
		return getTapeDeck().playRelays();
	}

	public static NoStrShareLinkProfile ofB32(String linkB32) {
		return new NoStrShareLinkProfile(OctoBech32String.of(linkB32));
	}
}
