package love.distributedrebirth.no2all.nostr.model.share;

import love.distributedrebirth.no2all.nostr.nip.NoStrImplShareLink;
import love.distributedrebirth.no2all.octo.OctoBech32String;
import love.distributedrebirth.no2all.octo.OctoBitFormat;

public final class NoStrShareLinkRelay extends NoStrShareB32LinkTLV {
	
	public NoStrShareLinkRelay(OctoBech32String link) {
		super(NoStrImplShareLink.RELAY, link);
	}

	public NoStrShareLinkRelay(String relayUrl) {
		super(NoStrImplShareLink.RELAY, tapeStudio -> {
			tapeStudio.recordSpecial(relayUrl, OctoBitFormat.UTF8);
		});
	}

	public String getRelayUrl() {
		return getTapeDeck().playSpecial(OctoBitFormat.UTF8).get();
	}

	public static NoStrShareLinkRelay ofB32(String linkB32) {
		return new NoStrShareLinkRelay(OctoBech32String.of(linkB32));
	}
}
