package love.distributedrebirth.no2all.nostr.model.tag;

import java.util.Optional;

import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackFishWelder;
import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackWelder;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTagBase;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTag;
import love.distributedrebirth.no2all.nostr.nip.tag.NoStrImplTagClient;

public final class NoStrTagClient extends NoStrEventTagBase<NoStrImplTagClient> {

	public NoStrTagClient(String userAgent, Optional<String> version) {
		super(NoStrImplEventTag.CLIENT);
		setMetaArgumentStr(NoStrImplTagClient.USER_AGENT, userAgent);
		setMetaArgumentOptStr(NoStrImplTagClient.VERSION, version);
	}

	public NoStrTagClient(String[] args) {
		super(NoStrImplEventTag.CLIENT, args);
	}

	public String getUserAgent() {
		return getMetaArgument(NoStrImplTagClient.USER_AGENT).get();
	}

	public Optional<String> getVersion() {
		return getMetaArgument(NoStrImplTagClient.VERSION);
	}

	public interface FishWelder extends NoStrFireStackFishWelder {

		default NoStrFireStackWelder tagClient(String userAgent, Optional<String> version) {
			return tag(new NoStrTagClient(userAgent, version));
		}

		default NoStrFireStackWelder tagClient(String userAgent, String version) {
			return tagClient(userAgent, Optional.of(version));
		}

		default NoStrFireStackWelder tagClient(String userAgent) {
			return tagClient(userAgent, Optional.empty());
		}
	}
}
