package love.distributedrebirth.no2all.nostr.model.tag;

import java.util.Optional;

import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackFishWelder;
import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackWelder;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTagBase;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTag;
import love.distributedrebirth.no2all.nostr.nip.tag.NoStrImplTagContentWarning;
import love.distributedrebirth.no2all.nostr.nip.tag.NoStrImplTagContentWarningRGroup;

public final class NoStrTagContentWarning extends NoStrEventTagBase<NoStrImplTagContentWarning> {

	public NoStrTagContentWarning(Optional<String> reason, Optional<NoStrImplTagContentWarningRGroup> rateGroup) {
		super(NoStrImplEventTag.CONTENT_WARNING);
		setMetaArgumentOptStr(NoStrImplTagContentWarning.REASON, reason);
		setMetaArgumentOptQName(NoStrImplTagContentWarning.RATE_GROUP, rateGroup);
	}

	public NoStrTagContentWarning(String[] args) {
		super(NoStrImplEventTag.CONTENT_WARNING, args);
	}

	public Optional<String> getReason() {
		return getMetaArgument(NoStrImplTagContentWarning.REASON);
	}

	public Optional<NoStrImplTagContentWarningRGroup> getRateGroup() {
		return getMetaArgument(NoStrImplTagContentWarning.RATE_GROUP).flatMap(v -> NoStrImplTagContentWarningRGroup.valueOfQName(v));
	}

	public interface FishWelder extends NoStrFireStackFishWelder {

		default NoStrFireStackWelder tagContentWarning(Optional<String> reason, Optional<NoStrImplTagContentWarningRGroup> rateGroup) {
			return tag(new NoStrTagContentWarning(reason, rateGroup));
		}

		default NoStrFireStackWelder tagContentWarning(String reason, NoStrImplTagContentWarningRGroup rateGroup) {
			return tagContentWarning(Optional.of(reason), Optional.of(rateGroup));
		}

		default NoStrFireStackWelder tagContentWarning(String reason) {
			return tagContentWarning(Optional.of(reason), Optional.empty());
		}

		default NoStrFireStackWelder tagContentWarning() {
			return tagContentWarning(Optional.empty(), Optional.empty());
		}
	}
}
