package love.distributedrebirth.no2all.nostr.model.tag;

import java.util.Optional;

import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackFishWelder;
import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackWelder;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventId;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTagBase;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTag;
import love.distributedrebirth.no2all.nostr.nip.tag.NoStrImplTagE;
import love.distributedrebirth.no2all.nostr.nip.tag.NoStrImplTagEMarker;

public final class NoStrTagE extends NoStrEventTagBase<NoStrImplTagE> {
	
	public NoStrTagE(NoStrEventId eventId, Optional<String> relayUrl, Optional<NoStrImplTagEMarker> marker) {
		super(NoStrImplEventTag.E);
		setMetaArgumentStr(NoStrImplTagE.EVENT_ID, eventId.getHex());
		setMetaArgumentOptStr(NoStrImplTagE.RELAY_URL, relayUrl);
		setMetaArgumentOptQName(NoStrImplTagE.MARKER, marker);
	}

	public NoStrTagE(String[] args) {
		super(NoStrImplEventTag.E, args);
	}

	public NoStrEventId getEventId() {
		return NoStrEventId.ofHex(getMetaArgument(NoStrImplTagE.EVENT_ID).get());
	}

	public Optional<String> getRelayUrl() {
		return getMetaArgument(NoStrImplTagE.RELAY_URL);
	}

	public Optional<NoStrImplTagEMarker> getMarker() {
		return getMetaArgument(NoStrImplTagE.MARKER).flatMap(v -> NoStrImplTagEMarker.valueOfQName(v));
	}

	public interface FishWelder extends NoStrFireStackFishWelder {

		default NoStrFireStackWelder tagE(NoStrEventId eventId, Optional<String> relayUrl, Optional<NoStrImplTagEMarker> marker) {
			return tag(new NoStrTagE(eventId, relayUrl, marker));
		}

		default NoStrFireStackWelder tagE(NoStrEventId eventId, String relayUrl, NoStrImplTagEMarker marker) {
			return tagE(eventId, Optional.of(relayUrl), Optional.of(marker));
		}

		default NoStrFireStackWelder tagERelayUrl(NoStrEventId eventId, String relayUrl) {
			return tagE(eventId, Optional.of(relayUrl), Optional.empty());
		}

		default NoStrFireStackWelder tagEMarker(NoStrEventId eventId, NoStrImplTagEMarker marker) {
			return tagE(eventId, Optional.empty(), Optional.of(marker));
		}
	}
}
