package love.distributedrebirth.no2all.nostr.model.tag;

import java.util.Optional;

import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackFishWelder;
import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackWelder;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTagBase;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTag;
import love.distributedrebirth.no2all.nostr.nip.tag.NoStrImplTagI;
import love.distributedrebirth.no2all.nostr.nip.tag.NoStrImplTagIClaim;

public final class NoStrTagI extends NoStrEventTagBase<NoStrImplTagI> {

	public NoStrTagI(String platformIdentity, String proof) {
		super(NoStrImplEventTag.I);
		setMetaArgumentStr(NoStrImplTagI.PLATFORM_IDENTITY, platformIdentity);
		setMetaArgumentStr(NoStrImplTagI.PROOF, proof);
	}

	public NoStrTagI(String[] args) {
		super(NoStrImplEventTag.I, args);
	}

	public String getPlatformIdentity() {
		return getMetaArgument(NoStrImplTagI.PLATFORM_IDENTITY).get();
	}

	public String getProof() {
		return getMetaArgument(NoStrImplTagI.PROOF).get();
	}

	public String getIdentityName() {
		return NoStrImplTagIClaim.splitFromPlatformIdentity(getPlatformIdentity());
	}

	public Optional<NoStrImplTagIClaim> getIdentityClaim() {
		return NoStrImplTagIClaim.valueOfPlatformIdentity(getPlatformIdentity());
	}

	public interface FishWelder extends NoStrFireStackFishWelder {

		default NoStrFireStackWelder tagI(String platformIdentity, String proof) {
			return tag(new NoStrTagI(platformIdentity, proof));
		}

		default NoStrFireStackWelder tagI(NoStrImplTagIClaim claimPlatform, String claimIdentity, String proof) {
			return tagI(claimPlatform.getQName() + NoStrImplTagIClaim.SEPERATOR + claimIdentity, proof);
		}
	}
}
