package love.distributedrebirth.no2all.nostr.model.tag;

import java.util.Optional;

import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackFishWelder;
import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackWelder;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTagBase;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTag;
import love.distributedrebirth.no2all.nostr.nip.tag.NoStrImplTagImage;

public final class NoStrTagImage extends NoStrEventTagBase<NoStrImplTagImage> {

	public NoStrTagImage(String url, Optional<String> dimension) {
		super(NoStrImplEventTag.IMAGE);
		setMetaArgumentStr(NoStrImplTagImage.URL, url);
		setMetaArgumentOptStr(NoStrImplTagImage.DIMENSION, dimension);
	}

	public NoStrTagImage(String[] args) {
		super(NoStrImplEventTag.IMAGE, args);
	}

	public String getUrl() {
		return getMetaArgument(NoStrImplTagImage.URL).get();
	}

	public Optional<String> getDimension() {
		return getMetaArgument(NoStrImplTagImage.DIMENSION);
	}

	public Optional<Integer> getDimensionWidth() {
		return getDimension().map(v -> NoStrImplTagImage.splitDimensionToWidth(v));
	}

	public Optional<Integer> getDimensionHeight() {
		return getDimension().map(v -> NoStrImplTagImage.splitDimensionToHeight(v));
	}

	public interface FishWelder extends NoStrFireStackFishWelder {

		default NoStrFireStackWelder tagImage(String url, Optional<String> dimension) {
			return tag(new NoStrTagImage(url, dimension));
		}

		default NoStrFireStackWelder tagImage(String url) {
			return tagImage(url, Optional.empty());
		}

		default NoStrFireStackWelder tagImage(String url, String dimension) {
			return tagImage(url, Optional.of(dimension));
		}

		default NoStrFireStackWelder tagImage(String url, int width, int height) {
			return tagImage(url, Optional.of(NoStrImplTagImage.createDimension(width, height)));
		}
	}
}
