package love.distributedrebirth.no2all.nostr.model.tag;

import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackFishWelder;
import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackWelder;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTagBase;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTag;
import love.distributedrebirth.no2all.nostr.nip.tag.NoStrImplTagNonce;

public final class NoStrTagNonce extends NoStrEventTagBase<NoStrImplTagNonce> {

	public NoStrTagNonce(int difficulty) {
		super(NoStrImplEventTag.NONCE);
		setMetaArgumentStr(NoStrImplTagNonce.BEARER_PROOF, Integer.toString(NoStrImplTagNonce.DEFAULT_BEARER_PROOF));
		setMetaArgumentStr(NoStrImplTagNonce.DIFFICULTY, Integer.toString(difficulty));
	}

	public NoStrTagNonce(String[] args) {
		super(NoStrImplEventTag.NONCE, args);
	}

	public void setBearerProof(int bearerProof) {
		setMetaArgumentStr(NoStrImplTagNonce.BEARER_PROOF, Integer.toString(bearerProof));
	}

	public int getBearerProof() {
		return Integer.valueOf(getMetaArgument(NoStrImplTagNonce.BEARER_PROOF).get());
	}

	public int getDifficulty() {
		return Integer.valueOf(getMetaArgument(NoStrImplTagNonce.DIFFICULTY).get());
	}

	public interface FishWelder extends NoStrFireStackFishWelder {

		default NoStrFireStackWelder tagNonce(int difficulty) {
			return tag(new NoStrTagNonce(difficulty));
		}
	}
}
