package love.distributedrebirth.no2all.nostr.model.tag;

import java.time.Instant;

import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackFishWelder;
import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackWelder;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTagBaseMono;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTag;

public final class NoStrTagPublishedAt extends NoStrEventTagBaseMono {

	public NoStrTagPublishedAt(Instant publishedAt) {
		super(NoStrImplEventTag.PUBLISHED_AT);
		setMetaArgumentStr(Long.toString(publishedAt.getEpochSecond()));
	}

	public NoStrTagPublishedAt(String[] args) {
		super(NoStrImplEventTag.PUBLISHED_AT, args);
	}

	public Instant getPublishedAt() {
		return Instant.ofEpochSecond(Long.valueOf(getMetaArgument().get()));
	}

	public interface FishWelder extends NoStrFireStackFishWelder {

		default NoStrFireStackWelder tagPublishedAt(Instant publishedAt) {
			return tag(new NoStrTagPublishedAt(publishedAt));
		}

		default NoStrFireStackWelder tagPublishedAtNow() {
			return tagPublishedAt(Instant.now());
		}
	}
}
