package love.distributedrebirth.no2all.nostr.model.tag;

import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackFishWelder;
import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackWelder;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTagBase;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTag;
import love.distributedrebirth.no2all.nostr.nip.tag.NoStrImplTagSubject;

public final class NoStrTagSubject extends NoStrEventTagBase<NoStrImplTagSubject> {

	public NoStrTagSubject(String subject) {
		super(NoStrImplEventTag.SUBJECT);
		setMetaArgumentStr(NoStrImplTagSubject.SUBJECT, subject);
	}

	public NoStrTagSubject(String[] args) {
		super(NoStrImplEventTag.SUBJECT, args);
	}

	public String getSubject() {
		return getMetaArgument(NoStrImplTagSubject.SUBJECT).get();
	}

	public boolean hasReplyPrefix() {
		return NoStrImplTagSubject.hasReplyPrefix(getSubject());
	}

	public boolean hasChoppedPostfix() {
		return NoStrImplTagSubject.hasChoppedPostfix(getSubject());
	}

	public interface FishWelder extends NoStrFireStackFishWelder {

		default NoStrFireStackWelder tagSubject(String subject) {
			return tag(new NoStrTagSubject(NoStrImplTagSubject.limitLength(subject)));
		}

		default NoStrFireStackWelder tagSubjectReply(String subject) {
			if (NoStrImplTagSubject.hasReplyPrefix(subject)) {
				return tagSubject(subject);
			}
			return tagSubject(NoStrImplTagSubject.prefixSubject(subject));
		}
	}
}
