package love.distributedrebirth.no2all.nostr.model.tag;

import java.util.Optional;

import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackFishWelder;
import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackWelder;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTagBase;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTag;
import love.distributedrebirth.no2all.nostr.nip.tag.NoStrImplTagThumb;

public final class NoStrTagThumb extends NoStrEventTagBase<NoStrImplTagThumb> {

	public NoStrTagThumb(String url, Optional<String> dimension) {
		super(NoStrImplEventTag.THUMB);
		setMetaArgumentStr(NoStrImplTagThumb.URL, url);
		setMetaArgumentOptStr(NoStrImplTagThumb.DIMENSION, dimension);
	}

	public NoStrTagThumb(String[] args) {
		super(NoStrImplEventTag.THUMB, args);
	}

	public String getUrl() {
		return getMetaArgument(NoStrImplTagThumb.URL).get();
	}

	public Optional<String> getDimension() {
		return getMetaArgument(NoStrImplTagThumb.DIMENSION);
	}

	public Optional<Integer> getDimensionWidth() {
		return getDimension().map(v -> NoStrImplTagThumb.splitDimensionToWidth(v));
	}

	public Optional<Integer> getDimensionHeight() {
		return getDimension().map(v -> NoStrImplTagThumb.splitDimensionToHeight(v));
	}

	public interface FishWelder extends NoStrFireStackFishWelder {

		default NoStrFireStackWelder tagThumb(String url, Optional<String> dimension) {
			return tag(new NoStrTagThumb(url, dimension));
		}

		default NoStrFireStackWelder tagThumb(String url) {
			return tagThumb(url, Optional.empty());
		}

		default NoStrFireStackWelder tagThumb(String url, String dimension) {
			return tagThumb(url, Optional.of(dimension));
		}

		default NoStrFireStackWelder tagThumb(String url, int width, int height) {
			return tagThumb(url, Optional.of(NoStrImplTagThumb.createDimension(width, height)));
		}
	}
}
