package love.distributedrebirth.no2all.nostr.model.tag;

import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackFishWelder;
import love.distributedrebirth.no2all.nostr.fire.NoStrFireStackWelder;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEventTagBase;
import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTag;
import love.distributedrebirth.no2all.nostr.nip.tag.NoStrImplTagTitle;

public final class NoStrTagTitle extends NoStrEventTagBase<NoStrImplTagTitle> {

	public NoStrTagTitle(String title) {
		super(NoStrImplEventTag.TITLE);
		setMetaArgumentStr(NoStrImplTagTitle.TITLE, title);
	}

	public NoStrTagTitle(String[] args) {
		super(NoStrImplEventTag.TITLE, args);
	}

	public String getTitle() {
		return getMetaArgument(NoStrImplTagTitle.TITLE).get();
	}

	public boolean hasChoppedPostfix() {
		return NoStrImplTagTitle.hasChoppedPostfix(getTitle());
	}

	public interface FishWelder extends NoStrFireStackFishWelder {

		default NoStrFireStackWelder tagTitle(String title) {
			return tag(new NoStrTagTitle(NoStrImplTagTitle.limitLength(title)));
		}
	}
}
