package love.distributedrebirth.no2all.nostr.nip;

import java.util.Objects;

import love.distributedrebirth.no2all.octo.OctoBitFormat;

public class NoStrImplBinHexAdapter implements NoStrImplBinHex {

	private final byte[] valueBytes;
	private final String valueHex;
	private final String valueHexDipavali;

	public NoStrImplBinHexAdapter(byte[] value) {
		this.valueBytes = Objects.requireNonNull(value);
		this.valueHex = OctoBitFormat.HEX.fromBytes(value);
		this.valueHexDipavali = OctoBitFormat.HEX_DIPAVALI.fromBytes(value);
	}

	@Override
	public final byte[] getBytes() {
		return valueBytes;
	}

	@Override
	public final String getHex() {
		return valueHex;
	}

	@Override
	public String getHexDipavali() {
		return valueHexDipavali;
	}
}
