package love.distributedrebirth.no2all.nostr.nip;

import love.distributedrebirth.no2all.nostr.model.event.NoStrEventKindRange;

public enum NoStrImplEventKindRange implements NoStrEventKindRange {

	// Internal Nips
	UNKNOWN			(   -1,    -1),
	CHAT			(    0,   999),
	REGULAR			( 1000,  9999),
	REGULAR_REPL	(10000, 19999),
	EPHEMERAL		(20000, 29999),
	PARAM_REPL		(30000, 39999),
	// External Apps
	NOSTROCKET		(640000,649999),
	;

	private final int numberStart;
	private final int numberstop;

	private NoStrImplEventKindRange(int numberStart, int numberstop) {
		this.numberStart = numberStart;
		this.numberstop = numberstop;
	}

	@Override
	public String getQFlag() {
		return name();
	}

	@Override
	public int getNumberStart() {
		return numberStart;
	}

	@Override
	public int getNumberstop() {
		return numberstop;
	}

	@Override
	public boolean isReplaceable(int number) {
		if (number == 0 || number == 3 || number == 41) {
			return true;
		}
		if (this == REGULAR_REPL) {
			return true;
		}
		if (this == PARAM_REPL) {
			return true;
		}
		return false;
	}

	public static NoStrImplEventKindRange valueOfKind(int number) {
		for (NoStrImplEventKindRange range : values()) {
			if (number >= range.getNumberStart() && number <= range.getNumberstop()) {
				return range;
			}
		}
		return NoStrImplEventKindRange.UNKNOWN;
	}
}
