package love.distributedrebirth.no2all.nostr.nip;

import java.util.Objects;

public enum NoStrImplMessageOkReason {

	DEFAULT			(""),
	BLOCKED			("blocked:"),
	INVALID			("invalid:"),
	POW				("pow:"),
	RATE_LIMITED	("rate-limited:"),
	ERROR			("error:"),
	;

	private final String prefix;
	private final String prefixFormat;

	private NoStrImplMessageOkReason(String prefix) {
		this.prefix = prefix;
		this.prefixFormat = prefix + (prefix.isEmpty()?"":" ");
	}

	public String getPrefix() {
		return prefix;
	}

	public String format(String message) {
		return prefixFormat + Objects.requireNonNull(message);
	}

	public static NoStrImplMessageOkReason valueOfPrefix(String message) {
		Objects.requireNonNull(message);
		for (NoStrImplMessageOkReason reason : values()) {
			if (reason == DEFAULT) {
				continue;
			}
			if (message.startsWith(reason.getPrefix())) {
				return reason;
			}
		}
		return NoStrImplMessageOkReason.DEFAULT;
	}
}
