package love.distributedrebirth.no2all.nostr.nip;

import java.util.Objects;

import love.distributedrebirth.no2all.octo.OctoBech32;
import love.distributedrebirth.no2all.octo.OctoBech32String;

public enum NoStrImplShareLink { // TODO: add NIP dep
	// bare value bach32
	PRIVATE_KEY("nsec"),
	PUBLIC_KEY("npub"),
	NOTE("note"),
	// TLV values bach32
	PROFILE("nprofile"),
	EVENT("nevent"),
	RELAY("nrelay"),
	EVENT_REFERENCE("naddr"),
	//CHANNEL("nchannel"), //todo find docs

	PRIVATE_KEY_SECURE("ncryptsec"), // bip 49
//	PRIVATE_KEY_SECURE("nsecpw"),

//	SECURE_URL("nsurl"),
	;

	private final String prefix;

	private NoStrImplShareLink(String prefix) {
		this.prefix = prefix;
	}

	public String getPrefix() {
		return prefix;
	}

	public OctoBech32String validate(OctoBech32String link) {
		Objects.requireNonNull(link);
		Objects.requireNonNull(link.getValue());
		if (link.getValue().startsWith(getPrefix())) {
			return link;
		}
		throw new IllegalArgumentException("Wrong prefix; wanted " + getPrefix() + " got " + link.getValue());
	}

	public byte[] fromBech32(OctoBech32String link) {
		return OctoBech32.fromBech32(validate(link)).getData();
	}

	public String toBech32(byte[] data) {
		return OctoBech32.toBech32(getPrefix(), data).getValue();
	}
}
