package love.distributedrebirth.no2all.nostr.nip;

import love.distributedrebirth.no2all.octo.OctoBitChainFrameType;

public enum NoStrImplShareTLV implements OctoBitChainFrameType {

	SPECIAL(0), // pubkey/eventId/payload/etc
	RELAY(1),
	AUTHOR(2),
	KIND(3),

	// new
	CLIENT(4), // for appId

	// for "ncryptsec" ChaCha20-Poly1305 CIPHERTEXT is in SPECIAL
	VERSION(5), // one byte
	LOG_N(6), // one byte
	SALT(7), // 16 bytes random
	NONCE(8), // 24 bytes from ChaCha20-Poly1305
	LEVEL(9), // 1 byte to indicate security level of private key

	// for "nsecpw" (simple AES)
	//SALT,
	//IV

	// for "nsurl"
	//SURL,
	//PKCS_8, // (full ASN.1 DER packet)
	;

	private final byte typeByte;

	private NoStrImplShareTLV(int typeByte) {
		this.typeByte = (byte)typeByte;
	}

	@Override
	public byte getTypeByte() {
		return typeByte;
	}
}
