package love.distributedrebirth.no2all.nostr.nip.tag;

import java.util.Optional;

import love.distributedrebirth.no2all.nostr.nip.NoStrImplQName;

public enum NoStrImplTagIClaim implements NoStrImplQName {

	GITHUB,
	TWITTER,
	MASTODON,
	TELEGRAM,
	;

	public static final String SEPERATOR = ":";
	private final String jsonQName;

	private NoStrImplTagIClaim() {
		jsonQName = name().toLowerCase();
	}

	@Override
	public String getQName() {
		return jsonQName;
	}

	public static String splitFromPlatformIdentity(String claimUri) {
		int sepIdx = claimUri.indexOf(SEPERATOR);
		if (sepIdx == -1) {
			return claimUri;
		}
		if (sepIdx == claimUri.length() - 1) {
			return "";
		}
		return claimUri.substring(sepIdx + 1);
	}

	public static Optional<NoStrImplTagIClaim> valueOfPlatformIdentity(String claimUri) {
		for (NoStrImplTagIClaim claim : values()) {
			if (claimUri.startsWith(claim.getQName())) {
				return Optional.of(claim);
			}
		}
		return Optional.empty();
	}
}
