package love.distributedrebirth.no2all.nostr.nip.tag;

import java.util.Locale;

import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTagArgument;

public enum NoStrImplTagSubject implements NoStrImplEventTagArgument {
	SUBJECT,
	;

	public static final String REPLY_PREFIX = "Re:";
	public static final String REPLY_PREFIX_LOWER = REPLY_PREFIX.toLowerCase(Locale.ROOT);
	public static final String REPLY_PREFIX_UPPER = REPLY_PREFIX.toUpperCase(Locale.ROOT);

	public static boolean hasReplyPrefix(String subject) {
		if (subject.startsWith(REPLY_PREFIX)) {
			return true;
		}
		if (subject.startsWith(REPLY_PREFIX_LOWER)) {
			return true;
		}
		if (subject.startsWith(REPLY_PREFIX_UPPER)) {
			return true;
		}
		return false;
	}

	public static String prefixSubject(String subject) {
		return REPLY_PREFIX + " " + subject;
	}

	public static boolean isLengthValid(String subject) {
		return NoStrImplTagTitle.isLengthValid(subject);
	}

	public static String limitLength(String subject) {
		return NoStrImplTagTitle.limitLength(subject);
	}

	public static boolean hasChoppedPostfix(String subject) {
		return NoStrImplTagTitle.hasChoppedPostfix(subject);
	}
}
