package love.distributedrebirth.no2all.nostr.nip.tag;

import love.distributedrebirth.no2all.nostr.nip.NoStrImplEventTagArgument;

public enum NoStrImplTagTitle implements NoStrImplEventTagArgument {
	TITLE,
	;

	private static final int MAX_LENGTH = 64;
	private static final String CHOP_INDICATOR = "...";

	public static boolean isLengthValid(String title) {
		return title.length() < MAX_LENGTH;
	}

	public static String limitLength(String title) {
		if (isLengthValid(title)) {
			return title;
		}
		int idxChop = MAX_LENGTH - CHOP_INDICATOR.length();
		return title.substring(0, idxChop) + CHOP_INDICATOR;
	}

	public static boolean hasChoppedPostfix(String title) {
		return title.endsWith(CHOP_INDICATOR);
	}
}
