package love.distributedrebirth.no2all.nostr.model;

import java.io.StringReader;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import jakarta.json.Json;
import jakarta.json.JsonObject;
import jakarta.json.JsonReader;

public class NoStrProfileMetaDataTest {

	@Test
	public void testUnknownKeys() {
		JsonObject json = Json.createObjectBuilder()
			.add("display_name", "junit")
			.add("foo", "bar")
			.build();
		NoStrProfileMetaData profileData = new NoStrProfileMetaData(json);
		String jsonStr = profileData.toBible().toString();
		
		try (JsonReader read = Json.createReader(new StringReader(jsonStr))) {
			JsonObject jsonResult = read.readObject();
			NoStrProfileMetaData profileDataResult = new NoStrProfileMetaData(jsonResult);
			Assertions.assertEquals("junit", profileDataResult.getDisplayName());
			Assertions.assertEquals("bar", jsonResult.getString("foo"));
		}
	}
}
