package love.distributedrebirth.no2all.nostr.model;

import java.io.InputStreamReader;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import jakarta.json.Json;
import jakarta.json.JsonReader;

public class NoStrRelayInfoTest {

	// For Example wss://relay.snort.social
	//{
	//	  "id": "wss://relay.snort.social/",
	//	  "name": "Snort Relay",
	//etc
	
	@Test
	public void testRead() throws Exception {
		try (JsonReader read = Json.createReader(new InputStreamReader(getClass().getResourceAsStream("relay-info.json")))) {
			NoStrRelayInfo relayInfo = new NoStrRelayInfo(read.readObject());
			Assertions.assertEquals("eden.nostr.land", relayInfo.getName());
			Assertions.assertEquals("1.22.6", relayInfo.getVersion());
			Assertions.assertTrue(relayInfo.getSupportedNips().contains(11));
			Assertions.assertTrue(relayInfo.getSupportedNips().contains(40));
			Assertions.assertNotNull(relayInfo.getLimitation());
			Assertions.assertEquals(10, relayInfo.getLimitation().getMaxSubscriptions());
			Assertions.assertEquals(256, relayInfo.getLimitation().getMaxSubIdLength());
			Assertions.assertTrue(relayInfo.getFeesPublication().isEmpty());
			Assertions.assertFalse(relayInfo.getFeesAdmission().isEmpty());
			Assertions.assertEquals("msats", relayInfo.getFeesAdmission().get(0).getUnit());
		}
	}
}
