package love.distributedrebirth.no2all.nostr.model.share;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import love.distributedrebirth.no2all.nostr.model.event.NoStrEventId;

public class NoStrShareLinkEventTest {

	@Test
	public void testToObject() {
		NoStrEventId key1 = NoStrShareLinkEvent.ofB32("nevent1qqsqqrzm3u656gq2h47up0yph5632whtuu5zfs37sdxmtl4cxkguyrgvg94ye").getEventId();
		Assertions.assertEquals("000c5b8f354d200abd7dc0bc81bd35153aebe72824c23e834db5feb83591c20d", key1.getHex());
	}

	@Test
	public void testToString() {
		NoStrEventId eventId1 = NoStrEventId.ofHex("000c5b8f354d200abd7dc0bc81bd35153aebe72824c23e834db5feb83591c20d");
		NoStrShareLinkEvent linkEvent1 = new NoStrShareLinkEvent(eventId1);
		NoStrShareLinkNote linkNote1 = new NoStrShareLinkNote(eventId1);
		Assertions.assertEquals("nevent1qqsqqrzm3u656gq2h47up0yph5632whtuu5zfs37sdxmtl4cxkguyrgvg94ye", linkEvent1.toShareLink());
		Assertions.assertEquals("note1qqx9hre4f5sq40tacz7gr0f4z5awheegynpraq6dkhltsdv3cgxszha4k8", linkNote1.toShareLink());
		
		NoStrEventId eventId2 = NoStrEventId.ofHex("d94a3f4dd87b9a3b0bed183b32e916fa29c8020107845d1752d72697fe5309a5");
		NoStrShareLinkNote link2 = new NoStrShareLinkNote(eventId2);
		Assertions.assertEquals("note1m99r7nwc0wdrkzldrqan96gklg5usqspq7z9696j6unf0ljnpxjspqfw99", link2.toShareLink());
	}
}
