package love.distributedrebirth.no2all.nostr.model.share;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import love.distributedrebirth.no2all.nostr.model.NoStrIdentityPrivateKey;

public class NoStrShareLinkPrivateKeyTest {

	@Test
	public void testToObject() {
		NoStrIdentityPrivateKey key1 = NoStrShareLinkPrivateKey.ofB32("nsec1j4c6269y9w0q2er2xjw8sv2ehyrtfxq3jwgdlxj6qfn8z4gjsq5qfvfk99").getPrivateKey();
		Assertions.assertEquals("9571a568a42b9e05646a349c783159b906b498119390df9a5a02667155128028", key1.getHex());

		NoStrIdentityPrivateKey key2 = NoStrShareLinkPrivateKey.ofB32("nsec1vl029mgpspedva04g90vltkh6fvh240zqtv9k0t9af8935ke9laqsnlfe5").getPrivateKey();
		Assertions.assertEquals("67dea2ed018072d675f5415ecfaed7d2597555e202d85b3d65ea4e58d2d92ffa", key2.getHex());
	}

	@Test
	public void testToString() {
		NoStrIdentityPrivateKey key1 = NoStrIdentityPrivateKey.ofHex("9571a568a42b9e05646a349c783159b906b498119390df9a5a02667155128028");
		NoStrShareLinkPrivateKey keyLink1 = new NoStrShareLinkPrivateKey(key1);
		Assertions.assertEquals("nsec1j4c6269y9w0q2er2xjw8sv2ehyrtfxq3jwgdlxj6qfn8z4gjsq5qfvfk99", keyLink1.toShareLink());
	}
}
