package love.distributedrebirth.no2all.nostr.model.share;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import love.distributedrebirth.no2all.nostr.model.NoStrIdentityPublicKey;

public class NoStrShareLinkPublicKeyTest {

	@Test
	public void testToObject() {
		NoStrIdentityPublicKey key1 = NoStrShareLinkPublicKey.ofB32("npub10elfcs4fr0l0r8af98jlmgdh9c8tcxjvz9qkw038js35mp4dma8qzvjptg").getPublicKey();
		Assertions.assertEquals("7e7e9c42a91bfef19fa929e5fda1b72e0ebc1a4c1141673e2794234d86addf4e", key1.getHex());
	}

	@Test
	public void testToString() {
		NoStrShareLinkPublicKey key1 = new NoStrShareLinkPublicKey(NoStrIdentityPublicKey.ofHex("aa4fc8665f5696e33db7e1a572e3b0f5b3d615837b0f362dcb1c8068b098c7b4"));
		Assertions.assertEquals("npub14f8usejl26twx0dhuxjh9cas7keav9vr0v8nvtwtrjqx3vycc76qqh9nsy", key1.toShareLink());

		NoStrShareLinkPublicKey key2 = new NoStrShareLinkPublicKey(NoStrIdentityPublicKey.ofHex("3bf0c63fcb93463407af97a5e5ee64fa883d107ef9e558472c4eb9aaaefa459d"));
		Assertions.assertEquals("npub180cvv07tjdrrgpa0j7j7tmnyl2yr6yr7l8j4s3evf6u64th6gkwsyjh6w6", key2.toShareLink());
	}
}
