package love.distributedrebirth.no2all.nostr.nip;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

public class NoStrImplEventKindRangeTest {

	@Test
	public void testValueOfKindValid() {
		Assertions.assertEquals(NoStrImplEventKindRange.CHAT, NoStrImplEventKindRange.valueOfKind(0));
		Assertions.assertEquals(NoStrImplEventKindRange.CHAT, NoStrImplEventKindRange.valueOfKind(1));
		Assertions.assertEquals(NoStrImplEventKindRange.CHAT, NoStrImplEventKindRange.valueOfKind(999));
		
		Assertions.assertEquals(NoStrImplEventKindRange.REGULAR, NoStrImplEventKindRange.valueOfKind(1000));
		Assertions.assertEquals(NoStrImplEventKindRange.REGULAR, NoStrImplEventKindRange.valueOfKind(1001));
		Assertions.assertEquals(NoStrImplEventKindRange.REGULAR, NoStrImplEventKindRange.valueOfKind(9999));
		
		Assertions.assertEquals(NoStrImplEventKindRange.REGULAR_REPL, NoStrImplEventKindRange.valueOfKind(10000));
		Assertions.assertEquals(NoStrImplEventKindRange.REGULAR_REPL, NoStrImplEventKindRange.valueOfKind(10001));
		Assertions.assertEquals(NoStrImplEventKindRange.REGULAR_REPL, NoStrImplEventKindRange.valueOfKind(19999));
		
		Assertions.assertEquals(NoStrImplEventKindRange.EPHEMERAL, NoStrImplEventKindRange.valueOfKind(20000));
		Assertions.assertEquals(NoStrImplEventKindRange.EPHEMERAL, NoStrImplEventKindRange.valueOfKind(20001));
		Assertions.assertEquals(NoStrImplEventKindRange.EPHEMERAL, NoStrImplEventKindRange.valueOfKind(29999));
		
		Assertions.assertEquals(NoStrImplEventKindRange.PARAM_REPL, NoStrImplEventKindRange.valueOfKind(30000));
		Assertions.assertEquals(NoStrImplEventKindRange.PARAM_REPL, NoStrImplEventKindRange.valueOfKind(30001));
		Assertions.assertEquals(NoStrImplEventKindRange.PARAM_REPL, NoStrImplEventKindRange.valueOfKind(39999));
	}

	@Test
	public void testValueOfKindUnknown() {
		Assertions.assertEquals(NoStrImplEventKindRange.UNKNOWN, NoStrImplEventKindRange.valueOfKind(40000));
		Assertions.assertEquals(NoStrImplEventKindRange.UNKNOWN, NoStrImplEventKindRange.valueOfKind(40001));
		Assertions.assertEquals(NoStrImplEventKindRange.UNKNOWN, NoStrImplEventKindRange.valueOfKind(49999));
		
		Assertions.assertEquals(NoStrImplEventKindRange.UNKNOWN, NoStrImplEventKindRange.valueOfKind(-1));
		Assertions.assertEquals(NoStrImplEventKindRange.UNKNOWN, NoStrImplEventKindRange.valueOfKind(-2));
	}
}
