package love.distributedrebirth.no2all.nostr.nip;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

public class NoStrImplEventKindTest {

	@Test
	public void testValueOfKindValid() {
		Assertions.assertEquals(NoStrImplEventKind.METADATA, NoStrImplEventKind.valueOfKind(0));
		Assertions.assertEquals(NoStrImplEventKind.TEXT_NOTE, NoStrImplEventKind.valueOfKind(1));
		Assertions.assertEquals(NoStrImplEventKind.CHANNEL_SEND_MSG, NoStrImplEventKind.valueOfKind(42));
		Assertions.assertEquals(NoStrImplEventKind.LONG_FORM_CONTENT, NoStrImplEventKind.valueOfKind(30023));
	}

	@Test
	public void testValueOfKindFeature() {
		Assertions.assertEquals(NoStrImpl.NIP_1_BASE_PROTOCOL, NoStrImplEventKind.valueOfKind(0).getNip());
		Assertions.assertEquals(NoStrImpl.NIP_1_BASE_PROTOCOL, NoStrImplEventKind.valueOfKind(1).getNip());
		Assertions.assertEquals(NoStrImpl.NIP_28_PUBLIC_CHAT, NoStrImplEventKind.valueOfKind(42).getNip());
		Assertions.assertEquals(NoStrImpl.NIP_23_LONG_FORM_CONTENT, NoStrImplEventKind.valueOfKind(30023).getNip());
	}
}
