package love.distributedrebirth.no2all.nostr.nip;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

public class NoStrImplMessageOkReasonTest {

	@Test
	public void testValueOfPrefixDefault() {
		Assertions.assertEquals(NoStrImplMessageOkReason.DEFAULT, NoStrImplMessageOkReason.valueOfPrefix(""));
		Assertions.assertEquals(NoStrImplMessageOkReason.DEFAULT, NoStrImplMessageOkReason.valueOfPrefix("foo"));
		Assertions.assertEquals(NoStrImplMessageOkReason.DEFAULT, NoStrImplMessageOkReason.valueOfPrefix("bar"));
	}

	@Test
	public void testValueOfPrefixValid() {
		Assertions.assertEquals(NoStrImplMessageOkReason.BLOCKED, NoStrImplMessageOkReason.valueOfPrefix("blocked: junit"));
		Assertions.assertEquals(NoStrImplMessageOkReason.INVALID, NoStrImplMessageOkReason.valueOfPrefix("invalid: junit"));
		Assertions.assertEquals(NoStrImplMessageOkReason.POW, NoStrImplMessageOkReason.valueOfPrefix("pow: junit"));
		Assertions.assertEquals(NoStrImplMessageOkReason.RATE_LIMITED, NoStrImplMessageOkReason.valueOfPrefix("rate-limited: junit"));
		Assertions.assertEquals(NoStrImplMessageOkReason.ERROR, NoStrImplMessageOkReason.valueOfPrefix("error: junit"));
	}

	@Test
	public void testFormatDefault() {
		Assertions.assertEquals("junit", NoStrImplMessageOkReason.DEFAULT.format("junit"));
		Assertions.assertEquals("error: junit", NoStrImplMessageOkReason.DEFAULT.format("error: junit"));
	}

	@Test
	public void testFormatError() {
		Assertions.assertEquals("error: junit", NoStrImplMessageOkReason.ERROR.format("junit"));
	}
}
