package love.distributedrebirth.no2all.nostr.nip;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

public class NoStrImplTest {

	@Test
	public void testNumber() {
		Assertions.assertEquals(0, NoStrImpl.NIP_0_UNKNOWN.getNumber());
		Assertions.assertEquals(9, NoStrImpl.NIP_9_EVENT_DELETION.getNumber());
		Assertions.assertEquals(10, NoStrImpl.NIP_10_CORRECT_BASE_TAGS.getNumber());
		Assertions.assertEquals(33, NoStrImpl.NIP_33_PARA_REPLACEABLE_EVENTS.getNumber());
		Assertions.assertEquals(94, NoStrImpl.NIP_94_FILE_METADATA.getNumber());
	}

	@Test
	public void testValueOfNIP() {
		Assertions.assertEquals(NoStrImpl.NIP_0_UNKNOWN, NoStrImpl.valueOfNIP(0));
		Assertions.assertEquals(NoStrImpl.NIP_1_BASE_PROTOCOL, NoStrImpl.valueOfNIP(1));
	}

	@Test
	public void testValueOfNIPValid() {
		Assertions.assertTrue(NoStrImpl.valueOfNIPValid(0));
		Assertions.assertTrue(NoStrImpl.valueOfNIPValid(13));
		Assertions.assertFalse(NoStrImpl.valueOfNIPValid(-1));
		Assertions.assertFalse(NoStrImpl.valueOfNIPValid(666));
	}
}
