package love.distributedrebirth.no2all.nostr.nip.tag;

import java.util.Optional;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

public class NoStrImplTagIClaimTest {

	private static final String TEST_FOOBAR = "foobar:junit";
	private static final String TEST_GITHUB = "github:semisol";
	private static final String TEST_TWITTER = "twitter:semisol_public";
	private static final String TEST_MASTODON = "mastodon:bitcoinhackers.org/@semisol";
	private static final String TEST_TELEGRAM = "telegram:1087295469";

	@Test
	public void testValueOfPrefix() {
		Assertions.assertEquals(Optional.empty(), NoStrImplTagIClaim.valueOfPlatformIdentity(TEST_FOOBAR));
		Assertions.assertEquals(NoStrImplTagIClaim.GITHUB, NoStrImplTagIClaim.valueOfPlatformIdentity(TEST_GITHUB).get());
		Assertions.assertEquals(NoStrImplTagIClaim.TWITTER, NoStrImplTagIClaim.valueOfPlatformIdentity(TEST_TWITTER).get());
		Assertions.assertEquals(NoStrImplTagIClaim.MASTODON, NoStrImplTagIClaim.valueOfPlatformIdentity(TEST_MASTODON).get());
		Assertions.assertEquals(NoStrImplTagIClaim.TELEGRAM, NoStrImplTagIClaim.valueOfPlatformIdentity(TEST_TELEGRAM).get());
	}

	@Test
	public void testSplitToIdentity() {
		Assertions.assertEquals("junit", NoStrImplTagIClaim.splitFromPlatformIdentity(TEST_FOOBAR));
		Assertions.assertEquals("semisol", NoStrImplTagIClaim.splitFromPlatformIdentity(TEST_GITHUB));
	}

	@Test
	public void testSplitToIdentityInvalid() {
		Assertions.assertEquals("", NoStrImplTagIClaim.splitFromPlatformIdentity(""));
		Assertions.assertEquals("123", NoStrImplTagIClaim.splitFromPlatformIdentity("123"));
		Assertions.assertEquals("", NoStrImplTagIClaim.splitFromPlatformIdentity("123:"));
		Assertions.assertEquals("456", NoStrImplTagIClaim.splitFromPlatformIdentity("123:456"));
		
	}
}
