package love.distributedrebirth.no2all.octo.conv;

import love.distributedrebirth.no2all.octo.OctoBitConverter;

public final class OctoConvSLongBigIndian implements OctoBitConverter<Long> {

	@Override
	public Long fromBytes(byte[] data) {
		long result = 0;
		result += (data[0] << 0)  & 0xFFL;
		result += (data[1] << 8)  & 0xFF00L;
		result += (data[2] << 16) & 0xFF0000L;
		result += (data[3] << 24) & 0xFF000000L;
		result += ((long)data[4] << 32) & 0xFF00000000L;
		result += ((long)data[5] << 40) & 0xFF0000000000L;
		result += ((long)data[6] << 48) & 0xFF000000000000L;
		result += ((long)data[7] << 56) & 0xFF00000000000000L;
		return result;
	}

	@Override
	public byte[] toBytes(Long value) {
		long data = value.longValue();
		byte[] result = new byte[8];
		result[0] = (byte)(data >> 0);
		result[1] = (byte)(data >> 8);
		result[2] = (byte)(data >> 16);
		result[3] = (byte)(data >> 24);
		result[4] = (byte)(data >> 32);
		result[5] = (byte)(data >> 40);
		result[6] = (byte)(data >> 48);
		result[7] = (byte)(data >> 56);
		return result;
	}
}
