package love.distributedrebirth.no2all.octo.conv;

import java.nio.charset.Charset;
import java.util.Objects;

import love.distributedrebirth.no2all.octo.OctoBitConverter;

public final class OctoConvStringCharset implements OctoBitConverter<String> {

	private final Charset charset;
	
	public OctoConvStringCharset(Charset charset) {
		this.charset = Objects.requireNonNull(charset);
	}
	
	@Override
	public String fromBytes(byte[] data) {
		return new String(data, charset);
	}

	@Override
	public byte[] toBytes(String value) {
		return value.getBytes(charset);
	}
}
