package love.distributedrebirth.no2all.octo.conv;

import love.distributedrebirth.no2all.octo.OctoBitConverter;

public final class OctoConvStringHex implements OctoBitConverter<String> {

	private final char[] valueToHex = "0123456789abcdef".toCharArray();
	private final byte[] valueToBytes = new byte[128];
	
	public OctoConvStringHex() {
		for (int i = 0; i < valueToBytes.length; i++) {
			valueToBytes[i] = (byte)-1;
		}
		for (int i = 0; i < valueToHex.length; i++) {
			char c = valueToHex[i];
			valueToBytes[c] = (byte)i;
			if (!Character.isDigit(c)) {
				valueToBytes[Character.toUpperCase(c)] = (byte)i;
			}
		}
	}

	@Override
	public String fromBytes(byte[] data) {
		int dataLength = data.length;
		char[] hexChars = new char[dataLength * 2];
		for (int j = 0; j < dataLength; j++) {
			int v = data[j] & 0xFF;
			int idx = j * 2;
			hexChars[idx] = valueToHex[v >>> 4];
			hexChars[idx + 1] = valueToHex[v & 0x0F];
		}
		return new String(hexChars);
	}

	@Override
	public byte[] toBytes(String value) {
		int valueLength = value.length();
		byte[] buf = new byte[valueLength >>> 1];
		for (int i = 0; i < valueLength; i += 2) {
			byte v0 = valueToBytes[value.charAt(i)];
			byte v1 = valueToBytes[value.charAt(i + 1)];
			buf[i / 2] = (byte) ((v0 << 4) + v1);
		}
		return buf;
	}
}
