package love.distributedrebirth.no2all.octo.conv;

import java.net.IDN;
import java.nio.charset.StandardCharsets;

import love.distributedrebirth.no2all.octo.OctoBitConverter;

public final class OctoConvStringIDN implements OctoBitConverter<String> {

	@Override
	public String fromBytes(byte[] data) {
		return IDN.toUnicode(new String(data, StandardCharsets.US_ASCII), IDN.ALLOW_UNASSIGNED);
	}

	@Override
	public byte[] toBytes(String value) {
		return IDN.toASCII(value, IDN.ALLOW_UNASSIGNED).getBytes(StandardCharsets.US_ASCII);
	}
}
