package love.distributedrebirth.no2all.octo.conv;

import love.distributedrebirth.no2all.octo.OctoBitConverter;

public final class OctoConvUIntBigIndian implements OctoBitConverter<Long> {

	@Override
	public Long fromBytes(byte[] data) {
		long result = 0;
		result += (data[0] << 0)  & 0xFF;
		result += (data[1] << 8)  & 0xFF00;
		result += (data[2] << 16) & 0xFF0000;
		result += (data[3] << 24) & 0xFF000000;
		return result;
	}

	@Override
	public byte[] toBytes(Long value) {
		long data = value.longValue();
		byte[] result = new byte[4];
		result[0] = (byte)(data >> 0);
		result[1] = (byte)(data >> 8);
		result[2] = (byte)(data >> 16);
		result[3] = (byte)(data >> 24);
		return result;
	}
}
