package love.distributedrebirth.no2all.octo.trust;

import org.bouncycastle.asn1.sec.SECNamedCurves;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.crypto.params.ECDomainParameters;

public enum OctoTrustAESCurveX9EC {
	FACTORY;

	private static final String CURVE_NAME = "secp256k1";
	private final X9ECParameters curveX9;
	private final ECDomainParameters curveEC;

	private OctoTrustAESCurveX9EC() {
		curveX9 = SECNamedCurves.getByName(CURVE_NAME);
		curveEC = new ECDomainParameters(curveX9.getCurve(), curveX9.getG(), curveX9.getN(), curveX9.getH());
	}

	public X9ECParameters getCurveX9() {
		return curveX9;
	}

	public ECDomainParameters getCurveEC() {
		return curveEC;
	}
}
