package love.distributedrebirth.no2all.octo;

import java.nio.charset.StandardCharsets;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

public class OctoBech32Test {

	@Test
	public void testToBech32() {
		byte[] data = "abcd".getBytes(StandardCharsets.UTF_8);
		String b32 = OctoBech32.toBech32("junit", data).getValue();
		Assertions.assertEquals("junit1v93xxeqlhr26v", b32);
	}

	@Test
	public void testFromBech32() {
		String b32 = "junit1v93xxeqlhr26v";
		byte[] data = OctoBech32.fromBech32(OctoBech32String.of(b32)).getData();
		String result = new String(data, StandardCharsets.UTF_8);
		Assertions.assertEquals("abcd", result);
	}
}
