package love.distributedrebirth.no2all.octo.conv;

import java.nio.charset.StandardCharsets;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

public class OctoConvStringIDNTest {

	String validUrlFB = "facebook.com";
	String validUrlAbc = "www.google.com";
	String[][] testIDN = {
		{"www.fаcebook.com", "www.xn--fcebook-2fg.com"},
		{"www.faϲebook.com", "www.xn--faebook-6pf.com"},
		{"www.facеbook.com", "www.xn--facbook-9gg.com"},
		{"www.facebооk.com", "www.xn--facebk-0qfa.com"},
		{"ԝԝԝ.facebook.com", "xn--07aaa.facebook.com"},
		{"ԝԝԝ.fаϲеbооk.com", "xn--07aaa.xn--fbk-qzc85c5a5da.com"},
		{"www.googlе.com", "www.xn--googl-3we.com"},
		{"www.gооgle.com", "www.xn--ggle-55da.com"},
		{"ԝԝԝ.google.com", "xn--07aaa.google.com"},
		{"ԝԝԝ.gооglе.com", "xn--07aaa.xn--ggl-tdd6ba.com"},
	};

	@Test
	public void testFormatIDN() {
		OctoConvStringIDN IDN = new OctoConvStringIDN();
		for (String[] test: testIDN) {
			String ascii = new String(IDN.toBytes(test[0]), StandardCharsets.US_ASCII);
			Assertions.assertEquals(test[1], ascii);
			Assertions.assertFalse(validUrlFB.equals(ascii));
			Assertions.assertFalse(validUrlAbc.equals(ascii));
		}
	}
}
