package love.distributedrebirth.no2all.octo.trust;

import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import love.distributedrebirth.no2all.octo.OctoBitFormat;

public class OctoTrustAESTest {

	@Test
	public void testPrivateKeyPassword() throws Exception {
		byte[] salt = "1234567890".getBytes();
		SecretKey k1 = OctoTrustAES.createSecretPassword("foobar".toCharArray(), salt);
		SecretKey k2 = OctoTrustAES.createSecretPassword("foobar".toCharArray(), salt);
		IvParameterSpec iv1 = OctoTrustAES.createRandomIv();
		IvParameterSpec iv2 = iv1;

		byte[] nsec = OctoTrust.generateSecretKey();
		System.out.println("nsec: " + OctoBitFormat.HEX.fromBytes(nsec));
		byte[] nsecpw = OctoTrustAES.encrypt(nsec, k1, iv1);
		System.out.println("nsecpw: " + OctoBitFormat.HEX.fromBytes(nsecpw));
		byte[] nsec2 = OctoTrustAES.decrypt(nsecpw, k2, iv2);
		System.out.println("nsec2: " + OctoBitFormat.HEX.fromBytes(nsec2));
		Assertions.assertArrayEquals(nsec, nsec2);
//		
//		// TEST END HERE
//		// wip
//		
//		//String algo = "PBKDF2WithHmacSHA256";
//		String algo = "PBEWithSHA1AndDESede";
//		AlgorithmParameters algparms = AlgorithmParameters.getInstance(algo);
//		PBEParameterSpec pbeParamSpec = new PBEParameterSpec(salt, 33);
//		algparms.init(pbeParamSpec);
//		//algparms.init(new IvParameterSpec(iv)); // for "AES" params
//		EncryptedPrivateKeyInfo encinfo = new EncryptedPrivateKeyInfo(algparms, nsecpw);
//
//		byte[] encryptedPkcs8 = encinfo.getEncoded();
//		String b32Pkcs8 = OctoBech32.toBech32("ntest", encryptedPkcs8).getValue();
//		System.out.println("pkcs8-hex: " + OctoBitFormat.HEX.fromBytes(encryptedPkcs8));
//		System.out.println("pkcs8-b32: " + b32Pkcs8);
//		byte[] linkData = OctoBech32.fromBech32(OctoBech32String.of(b32Pkcs8)).getData();
//		
//		EncryptedPrivateKeyInfo info = new EncryptedPrivateKeyInfo(linkData);
//		byte[] nsec3 = info.getEncryptedData();
//		System.out.println("asn.name: " + info.getAlgName());
//		System.out.println("asn.param: " + info.getAlgParameters());
//		System.out.println("nsec3: " + OctoBitFormat.HEX.fromBytes(nsec3));
//		Assertions.assertArrayEquals(nsecpw, nsec3);
//
//		Cipher cipher = Cipher.getInstance(info.getAlgName());
//		PBEKeySpec pbeKeySpec = new PBEKeySpec("foobar".toCharArray());
//		SecretKeyFactory secFac = SecretKeyFactory.getInstance(info.getAlgName());
//		Key pbeKey = secFac.generateSecret(pbeKeySpec);
//		AlgorithmParameters algParams = info.getAlgParameters();
//		cipher.init(Cipher.DECRYPT_MODE, pbeKey, algParams);
		
		// err
		//KeySpec pkcs8KeySpec = info.getKeySpec(cipher);
		//KeyFactory kf = KeyFactory.getInstance("PBEWithSHA1AndDESede");
		//byte[] nsec4 = kf.generatePrivate(pkcs8KeySpec).getEncoded();
		//System.out.println("nsec4: " + NoStrOctoBitFormat.HEX.fromBytes(nsec4));
	}

}
