package love.distributedrebirth.no2all.react.nostr.client;

import java.io.IOException;
import java.io.StringReader;
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;


import love.distributedrebirth.no2all.nostr.model.NoStrRelayInfo;

import java.net.http.HttpResponse.BodyHandlers;

import jakarta.json.Json;
import jakarta.json.JsonReader;

public class NoStrRelayFetchInfo {

	public NoStrRelayInfo fetchRelayInfo(URI uri) throws IOException, InterruptedException {
		HttpRequest request = HttpRequest.newBuilder(uri).header("Accept", "application/nostr+json").build();
		HttpResponse<String> response = HttpClient.newHttpClient().send(request, BodyHandlers.ofString());
		if (response.statusCode() != 200) {
			return null;
		}
		String contentJson = response.body();
		try (JsonReader read = Json.createReader(new StringReader(contentJson))) {
			NoStrRelayInfo result = new NoStrRelayInfo(read.readObject());
			return result;
		}
	}
}
