package love.distributedrebirth.no2all.react.nostr.server.relay;

import love.distributedrebirth.no2all.nostr.model.message.NoStrMsgToRelayClose;
import love.distributedrebirth.no2all.nostr.model.message.NoStrMsgToRelayReq;
import love.distributedrebirth.no2all.react.No2AllReactSlotLoad;
import love.distributedrebirth.no2all.react.No2AllReact;
import love.distributedrebirth.no2all.react.No2AllReactSlot;
import love.distributedrebirth.no2all.react.No2AllReactSlotSignal;
import love.distributedrebirth.no2all.react.No2AllReactTypeScript;
import love.distributedrebirth.no2all.react.wire.server.No2AllArtServer;
import love.distributedrebirth.no2all.react.wire.server.No2AllArtServerSocket;
import love.distributedrebirth.no2all.react.wire.server.No2AllRtsServer;

public class NoStrRtsServerRelaySubs implements No2AllReactTypeScript {

	public static final No2AllReactSlot API = No2AllReactSlot.ofClass(NoStrRtsServerRelaySubs.class);
	
	@Override
	public void onEvent(No2AllReactSlotSignal<No2AllReactSlotLoad> signal) {
		No2AllReact react = signal.getReact();
		react.claim(API);
		react.requireSlot(API, NoStrRtsServerRelay.API);
		react.registrate(No2AllRtsServer.API, No2AllArtServer.class, v -> {
			No2AllReactSlot serverSlot = v.getData().getSlot();
			react.registrate(serverSlot, No2AllArtServerSocket.class, x -> {
				No2AllReactSlot socketSlot = x.getData().getSlot();
				react.registrate(socketSlot, NoStrMsgToRelayReq.class, y -> {
					String subId = y.getData().getSubscriptionId();
					y.getData().getFilters();
					System.out.println("sub new: " + subId);
				});
				react.registrate(socketSlot, NoStrMsgToRelayClose.class, y -> {
					String subId = y.getData().getSubscriptionId();
					System.out.println("sub clone: " + subId);
				});
			});
		});
	}
}
