package love.distributedrebirth.no2all.react.nostr.server;

import java.net.InetSocketAddress;

import love.distributedrebirth.no2all.react.No2AllReactSlot;
import love.distributedrebirth.no2all.react.nostr.server.relay.NoStrRtsServerRelay;
import love.distributedrebirth.no2all.react.nostr.server.relay.NoStrRtsServerRelaySubs;
import love.distributedrebirth.no2all.react.warp.No2AllReactWarpCore;
import love.distributedrebirth.no2all.react.warp.No2AllRtsWarpSpeedMonitor;
import love.distributedrebirth.no2all.react.wire.server.No2AllActServer;
import love.distributedrebirth.no2all.react.wire.server.No2AllArtServer;
import love.distributedrebirth.no2all.react.wire.server.No2AllArtServerOnStart;
import love.distributedrebirth.no2all.react.wire.server.No2AllArtServerSocket;
import love.distributedrebirth.no2all.react.wire.server.No2AllArtServerSocketOnClose;
import love.distributedrebirth.no2all.react.wire.server.No2AllRtsServerLog;
import love.distributedrebirth.no2all.react.wire.server.No2AllRtsServer;
import love.distributedrebirth.no2all.wire.ojw.OjwWireServer;
import love.distributedrebirth.no2all.wire.ojw.OjwWireServerEndpoint;

public class NoStrServerTest {
	static OjwWireServer server = null;
	public static void main(String[] args) throws Exception {
		No2AllReactWarpCore react = new No2AllReactWarpCore();
		react.load(new No2AllRtsWarpSpeedMonitor());
		react.load(new No2AllRtsServer());
		react.load(new No2AllRtsServerLog());
		react.load(new NoStrRtsServer());
		react.load(new NoStrRtsServerRelay());
		react.load(new NoStrRtsServerRelaySubs());
		
		react.registrate(No2AllRtsServer.API, No2AllArtServer.class, artServer -> {
			No2AllReactSlot serverSlot = artServer.getData().getSlot();
			react.registrate(serverSlot, No2AllArtServerOnStart.class, v -> {
				System.out.println("RelayServer started: " + v.getTarget().getSlotSlug());
			});
			react.registrate(serverSlot, No2AllArtServerSocket.class, v -> {
				System.out.println("RelayServer client-open: " + v.getData().getSlot().getSlotPath());
				react.registrate(v.getData().getSlot(), No2AllArtServerSocketOnClose.class, y -> {
					System.out.println("RelayServer client-close: " + y.getData().getCode() + " of: " + y.getTarget().getSlotPath());
				});
			});
			react.registrate(serverSlot, OjwWireServer.class, x -> { // TODO: add interface matching ...
				server = x.getData();
			});
		});
		System.out.println("RelayServer fire configs");
		OjwWireServerEndpoint serverEndpoint = new OjwWireServerEndpoint(new InetSocketAddress(8080), 120);
		react.fire(No2AllRtsServer.API, new No2AllActServer(serverEndpoint));
		
		for (int i=0;i<1000;i++) {
			//react.fire(No2AllServerRTS.API, react);
			Thread.sleep(100);
		}
		
		Thread.sleep(40000);
		
		if (server !=  null) {
			System.out.println("RelayServers stopping");
			server.getHandler().stop();
		}
		
		//react.fireForEach(No2AllServerRTS.API, new No2AllActServerStop());
		System.out.println("RelayServers stopped");
	}
}
