package love.distributedrebirth.no2all.react.wire.server;

import love.distributedrebirth.no2all.react.No2AllReactSlotLoad;

import java.util.logging.Logger;

import love.distributedrebirth.no2all.react.No2AllReact;
import love.distributedrebirth.no2all.react.No2AllReactSlot;
import love.distributedrebirth.no2all.react.No2AllReactSlotSignal;
import love.distributedrebirth.no2all.react.No2AllReactTypeScript;

public class No2AllRtsServerLog implements No2AllReactTypeScript {

	public static final No2AllReactSlot API = No2AllReactSlot.ofClass(No2AllRtsServerLog.class);
	private static final Logger logger = Logger.getLogger(No2AllRtsServerLog.class.getName());

	@Override
	public void onEvent(No2AllReactSlotSignal<No2AllReactSlotLoad> signal) {
		No2AllReact react = signal.getReact();
		react.claim(API);
		react.registrate(No2AllRtsServer.API, No2AllArtServer.class, artServer -> {
			No2AllReactSlot serverSlot = artServer.getData().getSlot();
			react.registrate(serverSlot, No2AllActServerBroadcastMessage.class, v -> {
				logger.info("broadcastMessage: " + v.getData().getMessage());
			});
			react.registrate(serverSlot, No2AllArtServerSocket.class, v -> {
				No2AllReactSlot socketSlot = v.getData().getSlot();
				String wireId = socketSlot.getSlotSlug();
				react.registrate(socketSlot, No2AllArtServerSocketOnMessage.class, z -> {
					logger.info(wireId+".socketOnMessage: " + z.getData().getMessage());
				});
				react.registrate(socketSlot, No2AllActServerSocketSendMessage.class, z -> {
					logger.info(wireId+".socketSendMessage: " + z.getData().getMessage());
				});
			});
		});
	}
}
