package love.distributedrebirth.no2all.react.warp;

import love.distributedrebirth.no2all.react.No2AllReactSlotLoad;

import java.util.logging.Logger;

import love.distributedrebirth.no2all.react.No2AllReact;
import love.distributedrebirth.no2all.react.No2AllReactSlot;
import love.distributedrebirth.no2all.react.No2AllReactSlotSignal;
import love.distributedrebirth.no2all.react.No2AllReactTypeScript;

public class No2AllRtsWarpSpeedMonitor implements No2AllReactTypeScript {

	public static final No2AllReactSlot API = No2AllReactSlot.ofClass(No2AllRtsWarpSpeedMonitor.class);
	private static final No2AllReactSlot API_DILITHIUM = No2AllReactWarpCore.DILITHIUM;
	private static final Logger LOG = Logger.getLogger(No2AllRtsWarpSpeedMonitor.class.getName());

	@Override
	public void onEvent(No2AllReactSlotSignal<No2AllReactSlotLoad> signal) {
		No2AllReact react = signal.getReact();
		react.claim(API);
		react.requireSlot(API, API_DILITHIUM);
		react.registrate(API_DILITHIUM, No2AllArtWarpSlotAdd.class, v -> {
			LOG.fine("slot-add: " + v.getData().getSlot().getSlotPath());
		});
		react.registrate(API_DILITHIUM, No2AllArtWarpSlotRemove.class, v -> {
			LOG.fine("slot-remove: " + v.getData().getSlot().getSlotPath());
		});
	}
}
