package love.distributedrebirth.no2all.wire.jetty;

import java.net.URI;

import org.eclipse.jetty.websocket.client.WebSocketClient;

import love.distributedrebirth.no2all.wire.WireClient;
import love.distributedrebirth.no2all.wire.WireClientEndpoint;
import love.distributedrebirth.no2all.wire.WireClientHandler;

public class JettyWireClientEndpoint implements WireClientEndpoint {

	private final URI uri;
	private final WebSocketClient client;

	public JettyWireClientEndpoint(URI uri, WebSocketClient client) {
		this.uri = uri;
		this.client = client;
	}

	@Override
	public String wireId() {
		return uri.toString();
	}

	@Override
	public WireClient wireClient(WireClientHandler handler) {
		return new JettyWireClient(uri, client, handler);
	}
}
