package love.distributedrebirth.no2all.wire.jetty;

import java.nio.ByteBuffer;

import org.eclipse.jetty.websocket.api.Session;
import org.eclipse.jetty.websocket.api.WebSocketListener;

import love.distributedrebirth.no2all.wire.WireClientHandler;

public class JettyWireClientHandler implements WebSocketListener {

	private final WireClientHandler handler;

	protected JettyWireClientHandler(WireClientHandler handler) {
		this.handler = handler;
		this.handler.onStart();
	}

	@Override
	public void onWebSocketConnect(Session session) {
		handler.onOpen();
	}

	@Override
	public void onWebSocketClose(int statusCode, String reason) {
		handler.onClose(statusCode, reason, false);
	}

	@Override
	public void onWebSocketError(Throwable cause) {
		handler.onError(cause);
	}

	@Override
	public void onWebSocketBinary(byte[] payload, int offset, int len) {
		handler.onBinary(ByteBuffer.wrap(payload, offset, len));
	}

	@Override
	public void onWebSocketText(String message) {
		handler.onMessage(message);
	}
}
