package love.distributedrebirth.no2all.wire.jetty;

import java.io.IOException;
import java.nio.ByteBuffer;

import org.eclipse.jetty.websocket.server.JettyWebSocketServerContainer;

import love.distributedrebirth.no2all.wire.WireServer;
import love.distributedrebirth.no2all.wire.WireServerHandler;

public class JettyWireServer implements WireServer {

	private final JettyWebSocketServerContainer wsContainer;

	protected JettyWireServer(JettyWebSocketServerContainer wsContainer, String servletPath, WireServerHandler handler) {
		this.wsContainer = wsContainer;
		this.wsContainer.addMapping(servletPath, new JettyWireServerEndpointCreator(handler));
	}

	@Override
	public void broadcastMessage(String message) {
		wsContainer.getOpenSessions().forEach(v -> {
			try {
				v.getRemote().sendString(message);
			} catch (IOException e) {
				throw new IllegalStateException(e);
			}
		});
	}

	@Override
	public void broadcastBinary(ByteBuffer message) {
		wsContainer.getOpenSessions().forEach(v -> {
			try {
				v.getRemote().sendBytes(message);
			} catch (IOException e) {
				throw new IllegalStateException(e);
			}
		});
	}
}
