package love.distributedrebirth.no2all.wire.jetty;

import org.eclipse.jetty.websocket.server.JettyWebSocketServerContainer;

import love.distributedrebirth.no2all.wire.WireServer;
import love.distributedrebirth.no2all.wire.WireServerEndpoint;
import love.distributedrebirth.no2all.wire.WireServerHandler;

public class JettyWireServerEndpoint implements WireServerEndpoint {

	private final JettyWebSocketServerContainer wsContainer;
	private final String servletPath;

	public JettyWireServerEndpoint(JettyWebSocketServerContainer wsContainer, String servletPath) {
		this.wsContainer = wsContainer;
		this.servletPath = servletPath;
	}

	@Override
	public String wireId() {
		return servletPath;
	}

	@Override
	public WireServer wireServer(WireServerHandler handler) {
		return new JettyWireServer(wsContainer, servletPath, handler);
	}
}
