package love.distributedrebirth.no2all.wire.jetty;

import java.nio.ByteBuffer;

import org.eclipse.jetty.websocket.api.Session;
import org.eclipse.jetty.websocket.api.WebSocketListener;

import love.distributedrebirth.no2all.wire.WireServerHandler;

public class JettyWireServerHandler implements WebSocketListener {

	private final WireServerHandler handler;
	private JettyWireServerSocket conn;

	protected JettyWireServerHandler(WireServerHandler handler) {
		this.handler = handler;
		this.handler.onStart();
	}

	@Override
	public void onWebSocketConnect(Session session) {
		this.conn = new JettyWireServerSocket(session);
		handler.onOpen(conn);
	}

	@Override
	public void onWebSocketClose(int statusCode, String reason) {
		handler.onClose(conn, statusCode, reason, false);
	}

	@Override
	public void onWebSocketError(Throwable cause) {
		handler.onError(conn, cause);
	}

	@Override
	public void onWebSocketBinary(byte[] payload, int offset, int len) {
		handler.onBinary(conn, ByteBuffer.wrap(payload, offset, len));
	}

	@Override
	public void onWebSocketText(String message) {
		handler.onMessage(conn, message);
	}
}
