package love.distributedrebirth.no2all.wire.jetty;

import java.io.IOException;
import java.nio.ByteBuffer;

import org.eclipse.jetty.websocket.api.Session;

import love.distributedrebirth.no2all.wire.WireServerSocket;

public final class JettyWireServerSocket implements WireServerSocket {

	private final Session session;

	protected JettyWireServerSocket(Session session) {
		this.session = session;
	}

	@Override
	public String getRemoteAddress() {
		return session.getRemoteAddress().toString();
	}

	@Override
	public void sendMessage(String message) {
		try {
			session.getRemote().sendString(message);
		} catch (IOException e) {
			throw new IllegalStateException(e);
		}
	}

	@Override
	public void sendBinary(ByteBuffer message) {
		try {
			session.getRemote().sendBytes(message);
		} catch (IOException e) {
			throw new IllegalStateException(e);
		}
	}

	@Override
	public void close(int code, String message) {
		session.close(code, message);
	}
}
