package love.distributedrebirth.no2all.wire.jetty;

import java.net.URI;
import java.net.URISyntaxException;
import java.nio.ByteBuffer;

import org.eclipse.jetty.websocket.client.WebSocketClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import love.distributedrebirth.no2all.wire.WireClient;
import love.distributedrebirth.no2all.wire.WireClientHandler;

public class EventClient implements WireClientHandler {

	private static final Logger LOG = LoggerFactory.getLogger(EventClient.class);

	public static void main(String[] args) throws Exception {
		EventClient client = new EventClient();
		client.start();
		client.sendHallo();
		client.stop();
	}
	
	private WebSocketClient client;
	private JettyWireClientEndpoint endpoint1;
	
	public EventClient() throws URISyntaxException {
		client = new WebSocketClient();
		endpoint1 = new JettyWireClientEndpoint(new URI("ws://localhost:8080"), client);
	}

	public void start() throws Exception {
		client.start();
		LOG.info("client startup");
	}
	
	public void stop() throws Exception {
		client.stop();
	}
	
	public void sendHallo() {
		WireClient client1 = endpoint1.wireClient(this);
		client1.connect();
		client1.sendMessage("test me");
	}
	
	@Override
	public void onStart() {
		LOG.info("client.onStart()");
	}

	@Override
	public void onOpen() {
		LOG.info("client.onOpen()");
	}

	@Override
	public void onClose(int code, String reason, boolean remote) {
		LOG.info("client.onClose: "+code);
	}

	@Override
	public void onError(Throwable error) {
		LOG.info("client.onError: "+error.getMessage());
	}

	@Override
	public void onMessage(String message) {
		LOG.info("client.onMessage: "+message);
	}

	@Override
	public void onBinary(ByteBuffer message) {
		LOG.info("client.onBinary: "+message);
	}
}
