package love.distributedrebirth.no2all.wire.jre;

import java.net.URI;
import java.net.http.WebSocket;

import love.distributedrebirth.no2all.wire.WireClient;
import love.distributedrebirth.no2all.wire.WireClientEndpoint;
import love.distributedrebirth.no2all.wire.WireClientHandler;

public final class JreWireClientEndpoint implements WireClientEndpoint {

	private final URI uri;
	private final WebSocket.Builder wsBuilder;

	public JreWireClientEndpoint(URI uri, WebSocket.Builder wsBuilder) {
		this.wsBuilder = wsBuilder;
		this.uri = uri;
	}

	@Override
	public String wireId() {
		return uri.toString();
	}

	@Override
	public WireClient wireClient(WireClientHandler handler) {
		return new JreWireClient(uri, wsBuilder, handler);
	}
}
