package love.distributedrebirth.no2all.wire.jre;

import java.net.http.WebSocket;
import java.nio.ByteBuffer;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.CompletionStage;

import love.distributedrebirth.no2all.wire.WireClientHandler;

public final class JreWireClientHandler implements  WebSocket.Listener {

	private final WireClientHandler handler;

	protected JreWireClientHandler(WireClientHandler handler) {
		this.handler = handler;
		this.handler.onStart();
	}

	@Override
	public void onOpen(WebSocket ws) {
		handler.onOpen();
	}

	@Override
	public CompletionStage<?> onClose(WebSocket ws, int code, String reason) {
		handler.onClose(code, reason, true);
		return CompletableFuture.completedFuture("");
	}

	@Override
	public void onError(WebSocket ws, Throwable error) {
		handler.onError(error);
	}

	@Override
	public CompletionStage<?> onText(WebSocket ws, CharSequence data, boolean last) {
		handler.onMessage(data.toString());
		return CompletableFuture.completedFuture("");
	}

	@Override
	public CompletionStage<?> onBinary(WebSocket ws, ByteBuffer data, boolean last) {
		handler.onBinary(data);
		return CompletableFuture.completedFuture("");
	}
}