package love.distributedrebirth.no2all.wire.ojw;

import java.net.URI;
import java.nio.ByteBuffer;
import java.util.Map;

import love.distributedrebirth.no2all.wire.WireClient;
import love.distributedrebirth.no2all.wire.WireClientHandler;

public class OjwWireClient implements WireClient {

	private final OjwWireClientHandler handler;

	protected OjwWireClient(URI uri, Map<String, String> headers, int timeoutMs, WireClientHandler wireHandler) {
		this.handler = new OjwWireClientHandler(uri, headers, timeoutMs, wireHandler);
		wireHandler.onStart();
	}

	public OjwWireClientHandler getHandler() {
		return handler;
	}

	@Override
	public void connect() {
		handler.connect();
	}

	@Override
	public void close(int code, String message) {
		handler.close(code, message);
	}

	@Override
	public void sendMessage(String message) {
		handler.send(message);
	}

	@Override
	public void sendBinary(ByteBuffer message) {
		handler.send(message);
	}
}
