package love.distributedrebirth.no2all.wire.ojw;

import java.net.URI;
import java.util.Map;

import love.distributedrebirth.no2all.wire.WireClient;
import love.distributedrebirth.no2all.wire.WireClientEndpoint;
import love.distributedrebirth.no2all.wire.WireClientHandler;

public class OjwWireClientEndpoint implements WireClientEndpoint {

	private final URI uri;
	private final Map<String, String> headers;
	private final int timeoutMs;

	public OjwWireClientEndpoint(URI uri) {
		this(uri, null, 60 * 1000);
	}

	public OjwWireClientEndpoint(URI uri, Map<String, String> headers, int timeoutMs) {
		this.uri = uri;
		this.headers = headers;
		this.timeoutMs = timeoutMs;
	}

	@Override
	public String wireId() {
		return uri.toString();
	}

	@Override
	public WireClient wireClient(WireClientHandler handler) {
		return new OjwWireClient(uri, headers, timeoutMs, handler);
	}
}
