package love.distributedrebirth.no2all.wire.ojw;

import java.net.URI;
import java.nio.ByteBuffer;
import java.util.Map;

import org.java_websocket.client.WebSocketClient;
import org.java_websocket.drafts.Draft_6455;
import org.java_websocket.handshake.ServerHandshake;

import love.distributedrebirth.no2all.wire.WireClientHandler;

public class OjwWireClientHandler extends WebSocketClient {

	private final WireClientHandler handler;

	protected OjwWireClientHandler(URI uri, Map<String, String> headers, int timeoutMs, WireClientHandler handler) {
		super(uri, new Draft_6455(), headers, timeoutMs);
		this.handler = handler;
	}

	@Override
	public void onOpen(ServerHandshake handshakedata) {
		handler.onOpen();
	}

	@Override
	public void onClose(int code, String reason, boolean remote) {
		handler.onClose(code, reason, remote);
	}

	@Override
	public void onError(Exception ex) {
		handler.onError(ex);
	}

	@Override
	public void onMessage(String message) {
		handler.onMessage(message);
	}

	@Override
	public void onMessage(ByteBuffer message) {
		handler.onBinary(message);
	}
}
