package love.distributedrebirth.no2all.wire.ojw;

import java.net.InetSocketAddress;
import java.nio.ByteBuffer;

import love.distributedrebirth.no2all.wire.WireServer;
import love.distributedrebirth.no2all.wire.WireServerHandler;

public class OjwWireServer implements WireServer {

	private final OjwWireServerHandler handler;

	protected OjwWireServer(InetSocketAddress port, int pingTimeoutSecs, WireServerHandler handler) {
		this.handler = new OjwWireServerHandler(port, pingTimeoutSecs, handler);
		this.handler.start();
	}

	public OjwWireServerHandler getHandler() {
		return handler;
	}

	@Override
	public void broadcastMessage(String message) {
		handler.broadcast(message);
	}

	@Override
	public void broadcastBinary(ByteBuffer message) {
		handler.broadcast(message);
	}
}
