package love.distributedrebirth.no2all.wire.ojw;

import java.net.InetSocketAddress;

import love.distributedrebirth.no2all.wire.WireServer;
import love.distributedrebirth.no2all.wire.WireServerEndpoint;
import love.distributedrebirth.no2all.wire.WireServerHandler;

public class OjwWireServerEndpoint implements WireServerEndpoint {

	private final InetSocketAddress port;
	private final int pingTimeoutSecs;

	public OjwWireServerEndpoint(InetSocketAddress port, int pingTimeoutSecs) {
		this.port = port;
		this.pingTimeoutSecs = pingTimeoutSecs;
	}

	@Override
	public String wireId() {
		return port.toString();
	}

	@Override
	public WireServer wireServer(WireServerHandler handler) {
		return new OjwWireServer(port, pingTimeoutSecs, handler);
	}
}
