package love.distributedrebirth.no2all.wire.ojw;

import java.nio.ByteBuffer;

import org.java_websocket.WebSocket;

import love.distributedrebirth.no2all.wire.WireServerSocket;

public final class OjwWireServerSocket implements WireServerSocket {

	private final WebSocket socket;

	protected OjwWireServerSocket(WebSocket socket) {
		this.socket = socket;
	}

	@Override
	public String getRemoteAddress() {
		return socket.getRemoteSocketAddress().getAddress().getHostAddress();
	}

	@Override
	public void sendMessage(String message) {
		socket.send(message);
	}

	@Override
	public void sendBinary(ByteBuffer message) {
		socket.send(message);
	}

	@Override
	public void close(int code, String message) {
		socket.close(code, message);
	}
}
