package love.distributedrebirth.no2all.wire.fetch;

import java.net.URI;
import java.util.HashMap;
import java.util.Map;

public final class WireFetchResource {

	private final Map<String, String> headers = new HashMap<>();
	private final URI uri;
	private int timeoutMs = 10;

	public WireFetchResource(URI uri) {
		this.uri = uri;
		this.timeoutMs = 10;
	}

	public URI getUrId() {
		return uri;
	}

	public int getTimeoutMs() {
		return timeoutMs;
	}

	public Map<String, String> getHeaders() {
		return headers;
	}

	public WireFetchResource withTimeoutMs(int timeoutMs) {
		this.timeoutMs = timeoutMs;
		return this;
	}

	public WireFetchResource withHeader(String key, String value) {
		headers.put(key, value);
		return this;
	}
}
