package love.distributedrebirth.no2all.zerofungus;

import java.io.StringWriter;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.logging.Logger;

import javax.sql.DataSource;

import jakarta.json.Json;
import jakarta.json.JsonWriter;
import love.distributedrebirth.no2all.nostr.model.event.NoStrEvent;
import love.distributedrebirth.no2all.react.No2AllReact;
import love.distributedrebirth.no2all.react.No2AllReactSlot;
import love.distributedrebirth.no2all.react.No2AllReactSlotLoad;
import love.distributedrebirth.no2all.react.No2AllReactSlotSignal;
import love.distributedrebirth.no2all.react.No2AllReactTypeScript;
import love.distributedrebirth.no2all.react.nostr.server.relay.NoStrArtServerRelayStoreEvent;
import love.distributedrebirth.no2all.react.nostr.server.relay.NoStrRtsServerRelay;

public class ZFunRtsServer implements No2AllReactTypeScript {

	public static final No2AllReactSlot API = No2AllReactSlot.ofClass(ZFunRtsServer.class);
	private static final Logger logger = Logger.getLogger(ZFunRtsServer.class.getName());

	@Override
	public void onEvent(No2AllReactSlotSignal<No2AllReactSlotLoad> signal) {
		No2AllReact react = signal.getReact();
		react.claim(API);
		
		DataSource ds = react.service(DataSource.class);
		react.registrate(NoStrRtsServerRelay.API, NoStrArtServerRelayStoreEvent.class, storeEvent -> {
			logger.info("Store event: " + storeEvent.getData().getEvent().getId().getHexDipavali());
			NoStrEvent event = storeEvent.getData().getEvent();
			StringWriter jsonStr = new StringWriter();
			try (JsonWriter writer = Json.createWriter(jsonStr)) {
				writer.write(event.toBible());
			}
			try (Connection conn = ds.getConnection()) {
				String sql = "INSERT INTO \"ᔆʸᔆᐪᓫᔿ\".\"ᔆᐪᣔᒼᒽᑉ\" (\"ᑊᑊᐣ\",\"ᣖᓑᒃᒽᑉᓫᔾ\",\"ᒼᣗᓫᣔᐪᓫᐝᒄᐪ\",\"ᑊᑉᑊᣕᒄ\",\"ᒄᓫᒻᐪᣔᕐ\",\"ᓫᕁᣖᑊᣗᓫᐝᒄᐪ\",\"ᣗᣔᒡᒢ\") VALUES (?,?,?,?,?,?,?)";
				PreparedStatement prep = conn.prepareStatement(sql);
				prep.setString(1, event.getId().getHex());
				prep.setString(2, event.getPayload().getPublicKey().getHex());
				prep.setDate(3, new java.sql.Date(event.getPayload().getCreatedAt().toEpochMilli()));
				prep.setInt(4, event.getPayload().getKind().getNumber());
				prep.setString(5, null); // del tag
				prep.setString(6, null); // exp date
				prep.setString(7, jsonStr.toString());
				prep.executeUpdate();
			} catch (SQLException e) {
				logger.warning(e.getMessage());
			}
		});
	}
}
