package love.distributedrebirth.no2all.zerofungus.service;

import java.util.logging.Logger;

import org.slf4j.LoggerFactory;
import org.slf4j.bridge.SLF4JBridgeHandler;

import ch.qos.logback.core.status.NopStatusListener;
import love.distributedrebirth.no2all.react.No2AllReactSlot;
import love.distributedrebirth.no2all.react.No2AllReactSlotLoad;
import love.distributedrebirth.no2all.react.No2AllReactSlotSignal;
import love.distributedrebirth.no2all.react.No2AllReactTypeScript;

public class ZFunRtsConfigLogger implements No2AllReactTypeScript {

	public static final No2AllReactSlot API = No2AllReactSlot.ofClass(ZFunRtsConfigLogger.class);
	private static final Logger logger = Logger.getLogger(ZFunRtsConfigLogger.class.getName());

	@Override
	public void onEvent(No2AllReactSlotSignal<No2AllReactSlotLoad> signal) {
		if (System.getProperty("logback.configurationFile") == null) {
			String logConfig = null;
			if (System.getProperty("java.class.path").contains("classes")) {
				logConfig = "conf/logback-server-console.xml";
			} else {
				logConfig = "conf/logback-server.xml";
			}
			System.setProperty("logback.configurationFile", logConfig);
		}
		if (System.getProperty("logback.statusListenerClass") == null) {
			System.setProperty("logback.statusListenerClass",NopStatusListener.class.getName());
		}
		org.slf4j.Logger logger2 = LoggerFactory.getLogger(ZFunRtsConfigLogger.class);
		logger2.info("Logging configured.");
		
		SLF4JBridgeHandler.removeHandlersForRootLogger();
		SLF4JBridgeHandler.install();
		logger.info(" ╦┬ ┬╦    ╦═╗┌─┐╦ ╦┬╦═╗┌─┐╔╦╗");
		logger.info(" ║│ │║    ╠╦╝├┤ ║║║│╠╦╝├┤  ║║");
		logger.info("╚╝└─┘╩═╝  ╩╚═└─┘╚╩╝┴╩╚═└─┘═╩╝");
		//https://patorjk.com/software/taag
		// Calvin S
	}
}
