package love.distributedrebirth.no2all.zerofungus.service;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Logger;

import javax.sql.DataSource;

import org.flywaydb.core.Flyway;
import org.h2.jdbcx.JdbcConnectionPool;

import love.distributedrebirth.no2all.react.No2AllReactSlot;
import love.distributedrebirth.no2all.react.No2AllReactSlotLoad;
import love.distributedrebirth.no2all.react.No2AllReactSlotSignal;
import love.distributedrebirth.no2all.react.No2AllReactTypeScript;
import love.distributedrebirth.no2all.react.warp.No2AllReactWarpCore;

public class ZFunRtsInitJdbc implements No2AllReactTypeScript {

	public static final No2AllReactSlot API = No2AllReactSlot.ofClass(ZFunRtsInitJdbc.class);
	private static final Logger logger = Logger.getLogger(ZFunRtsInitJdbc.class.getName());
	private final No2AllReactWarpCore foei;

	public ZFunRtsInitJdbc(No2AllReactWarpCore foei) {
		this.foei = foei;
	}

	@Override
	public void onEvent(No2AllReactSlotSignal<No2AllReactSlotLoad> signal) {
		signal.getReact().claim(API);
		
		JdbcConnectionPool cp = JdbcConnectionPool.create("jdbc:h2:file:./target/h2db/zfun", "sa", "sa");
		foei.addService(JdbcConnectionPool.class, cp);
		foei.addService(DataSource.class, cp);
		
		Flyway flyway = Flyway.configure().schemas("ᔆʸᔆᐪᓫᔿ", "other", "ssd").table("ᣔᒃᣔᒼᓑᔆ").dataSource(cp).load();
		flyway.migrate();
		logger.info("╔╦╗┌─┐╔╦╗┌─┐╔╗ ┌─┐╔═╗┌─┐  ╔═╗┌─┐╔╦╗┬ ┬┌─┐");
		logger.info(" ║║├─┤ ║ ├─┤╠╩╗├─┤╚═╗├┤   ╚═╗├┤  ║ │ │├─┘");
		logger.info("═╩╝┴ ┴ ╩ ┴ ┴╚═╝┴ ┴╚═╝└─┘  ╚═╝└─┘ ╩ └─┘┴  ");
		try {
			startDone();
		} catch (SQLException e) {
			throw new IllegalStateException(e);
		}
	}

	public void startDone() throws SQLException {
		JdbcConnectionPool cp = foei.service(JdbcConnectionPool.class);
		try (Connection conn = cp.getConnection()) {
			String sql = "SELECT COUNT(\"ᑊᑊᐣ\") FROM \"ᔆʸᔆᐪᓫᔿ\".\"ᔆᐪᣔᒼᒽᑉ\"";
			PreparedStatement prep = conn.prepareStatement(sql);
			ResultSet rs = prep.executeQuery();
			if (rs.first()) {
				Long records = rs.getLong(1);
				logger.info("DB Records: " + records + " from: " + sql);
			}
		}
	}
}
